///////////////////////////////////////////////////////////
// CTOKEN.H 
///////////////////////////////////////////////////////////

enum TOKENTYPE // "tt"==Token Type
{  
	ttADD, ttSUBTRACT, ttMULTIPLY, ttDIVIDE,  
	ttMOD,                                               // Mathematical Operators

	ttNEGATIVE,                                          // Math Negator Operator

	ttNOT,                                               // Boolean Negator Operator

	ttAND, ttOR,                                         // Boolean Operators

	ttCOMPAREOP,                                         // Equality operators

	ttINT, ttFLOAT, ttBOOL, ttSTRING,                    // Constant Terminals

	ttGENETICFUNC, ttGENETICVAR, ttGENETICTERM,          // Genetic Individual Tokens

	ttNUMFUNCT, ttBOOLFUNCT, ttSTRFUNCT,                 // Unary Functions

	ttUSRFUNCTION,                                       // User Functions
	ttUSRATTRIB,										 // User Attributes

	ttFNMAP, ttFNIF, ttFNWHILE, ttFNDOUNTIL, 
	ttFNASSIGN, ttFNPUSH, ttFNPOP, ttFNREPLACE,
	ttFNGETAT, ttFNRETURN, ttFNGETARG, ttFNGETTARGET,
	ttFNVALUE, ttFNNOOP, ttFNDECLARE                     // Statements

};

class CToken 
{
public:
	CToken();
	CToken(TOKENTYPE InType, CString & InTokenVal);
	~CToken();

public:


	void SetType(TOKENTYPE InType);
	void SetVal (CString & InTokenVal);

	TOKENTYPE GetType();
	CString & GetVal();

	TOKENTYPE TokenType;
	CString TokenVal;

public:
	// Public functions relating to tokens
	TOKENTYPE GetTokenType(CString & TokenIn);

	public:


};

