// EnvironmentFormView.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"

#include "MainFrm.h"

#include "EnvironmentDoc.h"
#include "EnvironmentFormView.h"
#include "CGAPSIndividual.h"
#include "DlgGAPSOutput.h"
#include ".\MTRandom\randomc.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TRandomMersenne RandomGen ((long int) CTime::GetCurrentTime().GetYear() + 
	CTime::GetCurrentTime().GetMonth() +
	CTime::GetCurrentTime().GetDay() +
	CTime::GetCurrentTime().GetHour() +
	CTime::GetCurrentTime().GetMinute() +
	CTime::GetCurrentTime().GetSecond());

/////////////////////////////////////////////////////////////////////////////
// CEnvironmentFormView

IMPLEMENT_DYNCREATE(CEnvironmentFormView, CFormView)

CEnvironmentFormView::CEnvironmentFormView()
	: CFormView(CEnvironmentFormView::IDD)
{
	//{{AFX_DATA_INIT(CEnvironmentFormView)
	//}}AFX_DATA_INIT
	RunTime = NULL;
}

CEnvironmentFormView::~CEnvironmentFormView()
{
	if (RunTime != NULL)
		delete RunTime;
}

void CEnvironmentFormView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnvironmentFormView)
	DDX_Control(pDX, IDC_RIGHTHR2, m_RightHRScroller);
	DDX_Control(pDX, IDC_LEFTHR, m_LeftHRScroller);
	DDX_Control(pDX, IDC_HONORROLL5, m_HonorRollBtn5);
	DDX_Control(pDX, IDC_HONORROLL4, m_HonorRollBtn4);
	DDX_Control(pDX, IDC_HONORROLL3, m_HonorRollBtn3);
	DDX_Control(pDX, IDC_HONORROLL2, m_HonorRollBtn2);
	DDX_Control(pDX, IDC_HONORROLL1, m_HonorRollBtn1);
	DDX_Control(pDX, IDC_OUTPUTWINDOW, m_OutputWindow);
	DDX_Control(pDX, IDC_EXECPARMS, m_TabExecutionParms);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnvironmentFormView, CFormView)
	//{{AFX_MSG_MAP(CEnvironmentFormView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(IDME_FILE_SAVE, OnFileSave)
	ON_COMMAND(IDME_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(IDME_TBEXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_HONORROLL1, OnHonorroll1)
	ON_BN_CLICKED(IDC_HONORROLL2, OnHonorroll2)
	ON_BN_CLICKED(IDC_HONORROLL3, OnHonorroll3)
	ON_BN_CLICKED(IDC_HONORROLL4, OnHonorroll4)
	ON_BN_CLICKED(IDC_HONORROLL5, OnHonorroll5)
	ON_BN_CLICKED(IDC_LEFTHR, OnLefthr)
	ON_BN_CLICKED(IDC_RIGHTHR2, OnRighthr2)
	ON_COMMAND(IDME_TBSTOPEXEC, OnTbstopexec)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnvironmentFormView diagnostics

#ifdef _DEBUG
void CEnvironmentFormView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEnvironmentFormView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEnvironmentFormView message handlers

int CEnvironmentFormView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

void CEnvironmentFormView::OnInitialUpdate() 
{

	CString FormatIt;

	CFormView::OnInitialUpdate();
	
	m_HonorRollBtn1.ShowWindow(SW_HIDE);
	m_HonorRollBtn2.ShowWindow(SW_HIDE);
	m_HonorRollBtn3.ShowWindow(SW_HIDE);
	m_HonorRollBtn4.ShowWindow(SW_HIDE);
	m_HonorRollBtn5.ShowWindow(SW_HIDE);

	m_LeftHRScroller.ShowWindow(SW_HIDE);
	m_RightHRScroller.ShowWindow(SW_HIDE);

	// Must have an Image List for the Check Boxes to work on the 
	// Libraries Tree
	CImageList OurList;


	OurList.Create(16, 16, ILC_MASK, 0, 1);
	OurList.Add(AfxGetApp()->LoadIcon(IDI_GAPSICON));

	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	m_TabExecutionParms.Init();
	m_TabExecutionParms.InsertItem(0, "Environment Identification");
	m_TabExecutionParms.InsertItem(1, "Environmental Parameters");
	m_TabExecutionParms.InsertItem(2, "Targets");
	m_TabExecutionParms.InsertItem(3, "Attributes And Terminals");
	m_TabExecutionParms.InsertItem(4, "User Functions");
	m_TabExecutionParms.InsertItem(5, "Base Program");
	m_TabExecutionParms.InsertItem(6, "Fitness Calculation");


	OurTabIdent = (class CTabIdentification *) m_TabExecutionParms.m_tabPages[0];
	OurTabGenParms = (class CTabGeneralParms *) m_TabExecutionParms.m_tabPages[1];
	OurTabTargets = (class CTabTargets *) m_TabExecutionParms.m_tabPages[2];
	OurTabAttributesAndTerms = (class CTabAttributesAndTerms *) m_TabExecutionParms.m_tabPages[3];
	OurTabUserFunctions = (class CTabUserFunctions *) m_TabExecutionParms.m_tabPages[4];
	OurTabBaseProgram = (class CTabBaseProgram *) m_TabExecutionParms.m_tabPages[5];
	OurTabFitnessCalc = (class CTabFitnessCalc *) m_TabExecutionParms.m_tabPages[6];



	////////////////////////////////////////////////////////////
	// Initialize Tabs - New Environment
 	////////////////////////////////////////////////////////////

	if (!OurDoc->m_FileLoaded)
	{

		// Initialize General Parameters
		// Initialize Targets
		OurTabTargets->c_TargetList.InsertColumn(0, "Argument 0", LVCFMT_CENTER, 90);
		OurTabTargets->c_TargetList.InsertColumn(1, "Target Value", LVCFMT_CENTER, 100);

		OurTabTargets->c_NumArgumentsSlider.SetRangeMin(1);
		OurTabTargets->c_NumArgumentsSlider.SetRangeMax(6);
		OurTabTargets->c_NumArgumentsSlider.SetPos(1);
		OurTabTargets->c_NumArgumentsText.SetWindowText("1");
		OurTabTargets->m_NumArguments = 1;


	} // New environment

	////////////////////////////////////////////////////////////
	// Initialize Tabs - Loaded Environment
 	////////////////////////////////////////////////////////////
	else // (m_EnvironFileName is not empty)
	{
		int index;
		CString FormatIt;


		// Update Identification Tab
		OurTabIdent->c_EnvironmentName.SetWindowText(OurDoc->m_EnvironName);
		OurTabIdent->c_EnvironmentDescription.SetWindowText(OurDoc->m_EnvironDescr);

		// Update General Parameters Tab
		FormatIt.Format("%d", OurDoc->m_AbsoluteTimeLimit);
		OurTabGenParms->c_AbsoluteTimeLimit.SetWindowText(FormatIt);

		switch (OurDoc->m_GenerationStrategy)
		{
		case gs_GENFULL:
			OurTabGenParms->c_GenStratFull.SetCheck(TRUE);
			OurTabGenParms->c_GenStratGrow.SetCheck(FALSE);
			OurTabGenParms->c_GenStratHalf.SetCheck(FALSE);
			OurTabGenParms->c_MinDepthText.EnableWindow(FALSE);
			OurTabGenParms->c_MinDepth.EnableWindow(FALSE);
			break;
		case gs_GENGROW:
			OurTabGenParms->c_GenStratFull.SetCheck(FALSE);
			OurTabGenParms->c_GenStratGrow.SetCheck(TRUE);
			OurTabGenParms->c_GenStratHalf.SetCheck(FALSE);
			OurTabGenParms->c_MinDepth.EnableWindow(TRUE);
			break;
		case gs_GENHALF:
			OurTabGenParms->c_GenStratFull.SetCheck(FALSE);
			OurTabGenParms->c_GenStratGrow.SetCheck(FALSE);
			OurTabGenParms->c_GenStratHalf.SetCheck(TRUE);
			OurTabGenParms->c_MinDepthText.EnableWindow(TRUE);
			OurTabGenParms->c_MinDepth.EnableWindow(TRUE);
			break;
		}
		switch (OurDoc->m_SelectionStrategy)
		{
		case ss_FITNESS:
			OurTabGenParms->c_SelectionStratFit.SetCheck(TRUE);
			OurTabGenParms->c_SelectionStratOver.SetCheck(FALSE);
			OurTabGenParms->c_SelectionStratTourn.SetCheck(FALSE);
			break;
		case ss_OVERSEL:
			OurTabGenParms->c_SelectionStratFit.SetCheck(FALSE);
			OurTabGenParms->c_SelectionStratOver.SetCheck(TRUE);
			OurTabGenParms->c_SelectionStratTourn.SetCheck(FALSE);
			OurTabGenParms->c_SelectionStratSlider.EnableWindow(TRUE);
			OurTabGenParms->m_GroupISelPC = OurDoc->m_SelectionParmNum;
			OurTabGenParms->m_GroupIISelPC = (float) 100.0 - OurTabGenParms->m_GroupISelPC;
			FormatIt.Format("I: top %3.1f%c fitness-wise; II: remaining %3.1f%c", OurTabGenParms->m_GroupISelPC, '%', OurTabGenParms->m_GroupIISelPC, '%');
			OurTabGenParms->c_SelectionParmText.SetWindowText(FormatIt);
			OurTabGenParms->c_SelectionParmText.EnableWindow(TRUE);
			OurTabGenParms->c_SelectionStratSlider.SetPos((int) OurTabGenParms->m_GroupISelPC * OurTabGenParms->c_SelectionStratSlider.GetRangeMax() / 100);

			break;
		case ss_TOURN:
			OurTabGenParms->c_SelectionStratFit.SetCheck(FALSE);
			OurTabGenParms->c_SelectionStratOver.SetCheck(FALSE);
			OurTabGenParms->c_SelectionStratTourn.SetCheck(TRUE);
			OurTabGenParms->c_SelectionParmText.SetWindowText(CString("Tournament Size:"));
			FormatIt.Format("%d", OurDoc->m_TournamentSize);
			OurTabGenParms->c_SelectionParmNum.SetWindowText(FormatIt);
			OurTabGenParms->c_SelectionParmNum.EnableWindow(TRUE);

			break;
		}


		FormatIt.Format("%d", OurDoc->m_HonorRollSize);
		OurTabGenParms->c_HonorRollSize.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_MaximumDepth);
		OurTabGenParms->c_MaxDepth.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_MaxUnproductiveGens);
		OurTabGenParms->c_MaxUnproductiveGens.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_ShrinkageGenerations);
		OurTabGenParms->c_ShrinkageGenerations.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_MinimumDepth);
		OurTabGenParms->c_MinDepth.SetWindowText(FormatIt);
		FormatIt.Format("%f", OurDoc->m_MutationRate);
		OurTabGenParms->c_MutationRate.SetWindowText(FormatIt);
		FormatIt.Format("%ld", OurDoc->m_Population);
		OurTabGenParms->c_InitialPopulation.SetWindowText(FormatIt);
		FormatIt.Format("%f",  OurDoc->m_FitnessThreshold);
		OurTabGenParms->c_FitnessThreshold.SetWindowText(FormatIt);

		// Update Targets Tab
		OurTabTargets->c_NumArgumentsSlider.SetRangeMin(1);
		OurTabTargets->c_NumArgumentsSlider.SetRangeMax(6);
		OurTabTargets->c_NumArgumentsSlider.SetPos(OurDoc->m_NumArguments);
		OurTabTargets->m_NumArguments = OurDoc->m_NumArguments;
		if (OurTabTargets->m_NumArguments > 5)
		{
			OurTabTargets->c_Argument6.EnableWindow(TRUE);
			OurTabTargets->c_Argument6Type.EnableWindow(TRUE);
		}
		if (OurTabTargets->m_NumArguments > 4)
		{
			OurTabTargets->c_Argument5.EnableWindow(TRUE);
			OurTabTargets->c_Argument5Type.EnableWindow(TRUE);
		}
		if (OurTabTargets->m_NumArguments > 3)
		{
			OurTabTargets->c_Argument4.EnableWindow(TRUE);
			OurTabTargets->c_Argument4Type.EnableWindow(TRUE);
		}
		if (OurTabTargets->m_NumArguments > 2)
		{
			OurTabTargets->c_Argument3.EnableWindow(TRUE);
			OurTabTargets->c_Argument3Type.EnableWindow(TRUE);
		}
		if (OurTabTargets->m_NumArguments > 1)
		{
			OurTabTargets->c_Argument2.EnableWindow(TRUE);
			OurTabTargets->c_Argument2Type.EnableWindow(TRUE);
		}

		FormatIt.Format("%d",OurDoc->m_NumArguments);
		OurTabTargets->c_NumArgumentsText.SetWindowText(FormatIt);
	
		for (index = 0; index < OurDoc->m_NumArguments; index++)
		{
			CString ColHeader;
			ColHeader.Format("Argument %d", index);
			OurTabTargets->c_TargetList.InsertColumn(index, ColHeader, LVCFMT_CENTER, 90);
		}
		OurTabTargets->c_TargetList.InsertColumn(index, "Target Value", LVCFMT_CENTER, 100);
		struct ArgsAndTargets *CurrTarget;
		index = 0;
		for (CurrTarget = OurDoc->tbl_OurTargets; CurrTarget != NULL; CurrTarget = CurrTarget->next)
		{
			OurTabTargets->c_TargetList.InsertItem(index, "");
			OurTabTargets->c_TargetList.SetItemText(index, 0, CurrTarget->Arg1);
			FormatIt.Format("%s", CurrTarget->Arg1Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg1Type == rtBOOL ? CString("Boolean") : CString("String")));
			OurTabTargets->c_Argument1Type.SetWindowText(FormatIt);
			if (OurTabTargets->m_NumArguments > 1)
			{
				OurTabTargets->c_TargetList.SetItemText(index, 1, CurrTarget->Arg2);
				FormatIt.Format("%s", CurrTarget->Arg2Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg2Type == rtBOOL ? CString("Boolean") : CString("String")));
				OurTabTargets->c_Argument2Type.SetWindowText(FormatIt);
			}
			if (OurTabTargets->m_NumArguments > 2)
			{
				OurTabTargets->c_TargetList.SetItemText(index, 2, CurrTarget->Arg3);
				FormatIt.Format("%s", CurrTarget->Arg3Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg3Type == rtBOOL ? CString("Boolean") : CString("String")));
				OurTabTargets->c_Argument3Type.SetWindowText(FormatIt);
			}
			if (OurTabTargets->m_NumArguments > 3)
			{
				OurTabTargets->c_TargetList.SetItemText(index, 3, CurrTarget->Arg4);
				FormatIt.Format("%s", CurrTarget->Arg4Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg4Type == rtBOOL ? CString("Boolean") : CString("String")));
				OurTabTargets->c_Argument4Type.SetWindowText(FormatIt);
			}
			if (OurTabTargets->m_NumArguments > 4)
			{
				OurTabTargets->c_TargetList.SetItemText(index, 4, CurrTarget->Arg5);
				FormatIt.Format("%s", CurrTarget->Arg5Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg5Type == rtBOOL ? CString("Boolean") : CString("String")));
				OurTabTargets->c_Argument5Type.SetWindowText(FormatIt);
			}
			if (OurTabTargets->m_NumArguments > 5)
			{
				OurTabTargets->c_TargetList.SetItemText(index, 5, CurrTarget->Arg6);
				FormatIt.Format("%s", CurrTarget->Arg6Type == rtFLOAT ? CString("Number") : (CurrTarget->Arg6Type == rtBOOL ? CString("Boolean") : CString("String")));
				OurTabTargets->c_Argument6Type.SetWindowText(FormatIt);
			}
			OurTabTargets->c_TargetList.SetItemText(index, OurDoc->m_NumArguments, CurrTarget->TargetVal);
			FormatIt.Format("%s", CurrTarget->TargetType == rtFLOAT ? CString("Number") : (CurrTarget->TargetType == rtBOOL ? CString("Boolean") : CString("String")));
			OurTabTargets->c_TargetType.SetWindowText(FormatIt);

			index++;
		}

		// Update User Functions
		OurTabUserFunctions->m_TotalUserEnteredFunctions = OurDoc->m_TotalUserEnteredFunctions;
		for (index = 0; index < OurDoc->m_TotalUserEnteredFunctions; index++)
		{
			OurTabUserFunctions->a_UserEnteredFunctions[index].Name = OurDoc->a_UserEnteredFunctions[index].Name;
			OurTabUserFunctions->a_UserEnteredFunctions[index].Type = OurDoc->a_UserEnteredFunctions[index].Type;
			OurTabUserFunctions->a_UserEnteredFunctions[index].Text = OurDoc->a_UserEnteredFunctions[index].Text;
			OurTabUserFunctions->a_UserEnteredFunctions[index].TotalArguments = OurDoc->a_UserEnteredFunctions[index].TotalArguments;
			OurTabUserFunctions->a_UserEnteredFunctions[index].Selected = OurDoc->a_UserEnteredFunctions[index].Selected;


			HTREEITEM FunctItem;
			FunctItem = OurTabUserFunctions->c_UserFunctionSelection.InsertItem(OurDoc->a_UserEnteredFunctions[index].Name, OurTabUserFunctions->UserFnRoot);
			VERIFY(FunctItem != NULL);
			OurTabUserFunctions->c_UserFunctionSelection.SetCheck(FunctItem, OurDoc->a_UserEnteredFunctions[index].Selected);
			
			int argindex;
			for (argindex = 0; argindex < OurDoc->a_UserEnteredFunctions[index].TotalArguments; argindex++)
			{
				OurTabUserFunctions->a_UserEnteredFunctions[index].Arguments[argindex] = OurDoc->a_UserEnteredFunctions[index].Arguments[argindex];
				OurTabUserFunctions->a_UserEnteredFunctions[index].ArgumentTypes[argindex] = OurDoc->a_UserEnteredFunctions[index].ArgumentTypes[argindex];
			}
		}
		OurTabUserFunctions->c_UserFunctionSelection.Expand(OurTabUserFunctions->UserFnRoot, TVE_EXPAND);
		// Update Builtin Checks
		index = 0;
		
		for (index = 0; index < OurDoc->m_TotalSelectedBuiltIns; index++)
		{
			HTREEITEM EachItem;
			for (EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetChildItem(OurTabUserFunctions->BuiltInRoot); EachItem != NULL; EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetNextItem(EachItem, TVGN_NEXT))
			{
				if (OurTabUserFunctions->c_UserFunctionSelection.GetItemText(EachItem) == OurDoc->a_SelectedBuiltIns[index])
					OurTabUserFunctions->c_UserFunctionSelection.SetCheck(EachItem, TRUE);
			}
		}

		// Update Base Program
		OurTabBaseProgram->c_BaseProgramEntryPanel.SetWindowText(OurDoc->m_BaseProgram);

		// Update Fitness Calculation
		OurTabFitnessCalc->c_RawFitnessFormula.SetWindowText(OurDoc->m_RawFitnessFormula);
		OurTabFitnessCalc->c_StandardizedFitnessFormula.SetWindowText(OurDoc->m_StandardizedFitnessFormula);

		// Update Attributes and Terminals
		// Attributes
		OurTabAttributesAndTerms->c_AttributeList.DeleteAllItems();
		for (index = 0; index < OurDoc->m_TotalAttributes; index++)
		{
			OurTabAttributesAndTerms->c_AttributeList.InsertItem(index, "");
			OurTabAttributesAndTerms->c_AttributeList.SetItemText(index, 0, OurDoc->a_Attributes[index].Name);
			OurTabAttributesAndTerms->c_AttributeList.SetItemText(index, 1, OurDoc->a_Attributes[index].Type);
			OurTabAttributesAndTerms->c_AttributeList.SetItemText(index, 2, OurDoc->a_Attributes[index].IsPersistent ? CString("TRUE") : CString("FALSE"));
			OurTabAttributesAndTerms->c_AttributeList.SetItemText(index, 3, OurDoc->a_Attributes[index].IsSelectable ? CString("TRUE") : CString("FALSE"));

		}
		// Terminals
		OurTabAttributesAndTerms->c_TerminalSelectionAttributes.SetCheck(OurDoc->m_TermsSelectedAttributes);
		OurTabAttributesAndTerms->c_TerminalSelectionNumerics.SetCheck(OurDoc->m_TermsSelectedRandNums);
		if (OurTabAttributesAndTerms->c_TerminalSelectionNumerics.GetCheck())
		{
			OurTabAttributesAndTerms->c_NumericTerminalHigh.EnableWindow(TRUE);
			OurTabAttributesAndTerms->c_NumericTerminalLow.EnableWindow(TRUE);
			OurTabAttributesAndTerms->c_NumericTerminalPrecision.EnableWindow(TRUE);
		}
		FormatIt.Format("%d", OurDoc->m_TermsSelectedNumDecimals);
		OurTabAttributesAndTerms->c_NumericTerminalPrecision.SetWindowText(FormatIt);
		FormatIt.Format("%f", OurDoc->m_TermsSelectedNumLow);
		OurTabAttributesAndTerms->c_NumericTerminalLow.SetWindowText(FormatIt);
		FormatIt.Format("%f", OurDoc->m_TermsSelectedNumHigh);
		OurTabAttributesAndTerms->c_NumericTerminalHigh.SetWindowText(FormatIt);
		OurTabAttributesAndTerms->c_TerminalSelectionBooleans.SetCheck(OurDoc->m_TermsSelectedBools);
		OurTabAttributesAndTerms->c_TerminalSelectionString.SetCheck(OurDoc->m_TermsSelectedStrings);
		if (OurTabAttributesAndTerms->c_TerminalSelectionString.GetCheck())
		{
			OurTabAttributesAndTerms->c_TermCharRangeHigh.EnableWindow(TRUE);
			OurTabAttributesAndTerms->c_TermCharRangeLow.EnableWindow(TRUE);
			OurTabAttributesAndTerms->c_TermStringLengthHigh.EnableWindow(TRUE);
			OurTabAttributesAndTerms->c_TermStringLengthLow.EnableWindow(TRUE);
		}
		FormatIt.Format("%d", OurDoc->m_TermsSelectedCharLow);
		OurTabAttributesAndTerms->c_TermCharRangeLow.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_TermsSelectedCharHigh);
		OurTabAttributesAndTerms->c_TermCharRangeHigh.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_TermsSelectedCharLenLow);
		OurTabAttributesAndTerms->c_TermStringLengthLow.SetWindowText(FormatIt);
		FormatIt.Format("%d", OurDoc->m_TermsSelectedCharLenHigh);
		OurTabAttributesAndTerms->c_TermStringLengthHigh.SetWindowText(FormatIt);
		OurTabAttributesAndTerms->c_TerminalSelectionArgs.SetCheck(OurDoc->m_TermsSelectedArgs);
		
	
	}
}

void CEnvironmentFormView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

}

CEnvironmentDoc* CEnvironmentFormView::GetDocument()
{
	return (CEnvironmentDoc *) CView::GetDocument();
}


void CEnvironmentFormView::OnFileSave() 
{
	UpdateDoc();

	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	OurDoc->SaveEnvironment();
	OurDoc->m_FileLoaded = TRUE;
	SetWindowText(CString("GP-Lab ") + OurDoc->m_FileName);
	
}

void CEnvironmentFormView::OnFileSaveAs() 
{
	UpdateDoc();

	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	OurDoc->m_FileLoaded = FALSE;
	OurDoc->SaveEnvironment();
	OurDoc->m_FileLoaded = TRUE;

	SetWindowText(CString("GP-Lab ") + OurDoc->m_FileName);	

}


void CEnvironmentFormView::UpdateDoc()
{
	// Grab actual Environment Document
	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	// Store Identification
	OurTabIdent->c_EnvironmentName.GetWindowText(OurDoc->m_EnvironName);
	OurTabIdent->c_EnvironmentDescription.GetWindowText(OurDoc->m_EnvironDescr);

	// Store Environment Misc. Parameters
	CString GetVal;
	OurTabGenParms->c_MutationRate.GetWindowText(GetVal);
	OurDoc->m_MutationRate = atof(GetVal);
	OurTabGenParms->c_MaxUnproductiveGens.GetWindowText(GetVal);
	OurDoc->m_MaxUnproductiveGens = atoi(GetVal);
	OurTabGenParms->c_ShrinkageGenerations.GetWindowText(GetVal);
	OurDoc->m_ShrinkageGenerations = atoi(GetVal);
	OurTabGenParms->c_InitialPopulation.GetWindowText(GetVal);
	OurDoc->m_Population = atol(GetVal);
	OurTabGenParms->c_HonorRollSize.GetWindowText(GetVal);
	OurDoc->m_HonorRollSize = atoi(GetVal);
	OurTabGenParms->c_AbsoluteTimeLimit.GetWindowText(GetVal);
	OurDoc->m_AbsoluteTimeLimit = atoi(GetVal);
	OurTabGenParms->c_FitnessThreshold.GetWindowText(GetVal);
	OurDoc->m_FitnessThreshold = atof(GetVal);
	
	OurTabGenParms->c_MaxDepth.GetWindowText(GetVal);
	OurDoc->m_MaximumDepth = atoi(GetVal);
	OurTabGenParms->c_MinDepth.GetWindowText(GetVal);
	OurDoc->m_MinimumDepth = atoi(GetVal);
	OurDoc->m_SelectionParmNum = (double) OurTabGenParms->c_SelectionStratSlider.GetPos() / (double) OurTabGenParms->c_SelectionStratSlider.GetRangeMax() * 100.0;
	OurTabGenParms->c_SelectionParmNum.GetWindowText(GetVal);
	OurDoc->m_TournamentSize = atoi(GetVal);

	if (OurTabGenParms->c_GenStratFull.GetCheck())
		OurDoc->m_GenerationStrategy = gs_GENFULL;
	if (OurTabGenParms->c_GenStratGrow.GetCheck())
		OurDoc->m_GenerationStrategy= gs_GENGROW;
	if (OurTabGenParms->c_GenStratHalf.GetCheck())
		OurDoc->m_GenerationStrategy= gs_GENHALF;

	if (OurTabGenParms->c_SelectionStratFit.GetCheck())
		OurDoc->m_SelectionStrategy = ss_FITNESS;
	if (OurTabGenParms->c_SelectionStratOver.GetCheck())
		OurDoc->m_SelectionStrategy = ss_OVERSEL;
	if (OurTabGenParms->c_SelectionStratTourn.GetCheck())
		OurDoc->m_SelectionStrategy = ss_TOURN;


	// Store targets
	// Delete any list already present and re-create
	struct ArgsAndTargets *CurrNode;
	struct ArgsAndTargets *DelNode;

	for (CurrNode = OurDoc->tbl_OurTargets; CurrNode != NULL; )
	{
		DelNode = CurrNode;
		CurrNode = CurrNode->next;
		delete DelNode;
		DelNode = NULL;
	}

	OurDoc->tbl_OurTargets = NULL;
	OurDoc->m_NumArguments = OurTabTargets->m_NumArguments;
	OurDoc->m_NumTargets = 0;

	int index;
	for (index = 0; index < OurTabTargets->c_TargetList.GetItemCount(); index++)
	{
		if (OurDoc->tbl_OurTargets == NULL)
		{
			OurDoc->tbl_OurTargets = new struct ArgsAndTargets;
			CurrNode = OurDoc->tbl_OurTargets;
			CurrNode->next = NULL;
		}
		else
		{
			CurrNode->next = new struct ArgsAndTargets;
			CurrNode = CurrNode->next;
			CurrNode->next = NULL;
		}

		CurrNode->Arg1 = OurTabTargets->c_TargetList.GetItemText(index, 0);
		CString CheckTypeStr;

		OurTabTargets->c_Argument1Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg1Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg1Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg1Type = rtSTRING;

		if (OurTabTargets->m_NumArguments > 1)
			CurrNode->Arg2 = OurTabTargets->c_TargetList.GetItemText(index, 1);
		else
			CurrNode->Arg2 = CString(" ");
		OurTabTargets->c_Argument2Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg2Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg2Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg2Type = rtSTRING;

		if (OurTabTargets->m_NumArguments > 2)
			CurrNode->Arg3 = OurTabTargets->c_TargetList.GetItemText(index, 2);
		else
			CurrNode->Arg3 = CString(" ");
		OurTabTargets->c_Argument3Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg3Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg3Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg3Type = rtSTRING;

		if (OurTabTargets->m_NumArguments > 3)
			CurrNode->Arg4 = OurTabTargets->c_TargetList.GetItemText(index, 3);
		else
			CurrNode->Arg4 = CString(" ");
		OurTabTargets->c_Argument4Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg4Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg4Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg4Type = rtSTRING;

		if (OurTabTargets->m_NumArguments > 4)
			CurrNode->Arg5 = OurTabTargets->c_TargetList.GetItemText(index, 4);
		else
			CurrNode->Arg5 = CString(" ");
		OurTabTargets->c_Argument5Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg5Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg5Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg5Type = rtSTRING;

		if (OurTabTargets->m_NumArguments > 5)
			CurrNode->Arg6 = OurTabTargets->c_TargetList.GetItemText(index, 5);
		else
			CurrNode->Arg6 = CString(" ");
		OurTabTargets->c_Argument6Type.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->Arg6Type = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->Arg6Type = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->Arg6Type = rtSTRING;

		CurrNode->TargetVal = OurTabTargets->c_TargetList.GetItemText(index, OurTabTargets->m_NumArguments);
		OurTabTargets->c_TargetType.GetWindowText(CheckTypeStr);
		if (CheckTypeStr == CString("Number"))
			CurrNode->TargetType = rtFLOAT;
		if (CheckTypeStr == CString("Boolean"))
			CurrNode->TargetType = rtBOOL;
		if (CheckTypeStr == CString("String"))
			CurrNode->TargetType = rtSTRING;

		OurDoc->m_NumTargets++;
	}

	// Store User Functions
	OurDoc->m_TotalUserEnteredFunctions = OurTabUserFunctions->m_TotalUserEnteredFunctions;

	for (index = 0; index < OurTabUserFunctions->m_TotalUserEnteredFunctions; index++)
	{
		OurDoc->a_UserEnteredFunctions[index].Name = OurTabUserFunctions->a_UserEnteredFunctions[index].Name;
		OurDoc->a_UserEnteredFunctions[index].Type = OurTabUserFunctions->a_UserEnteredFunctions[index].Type;
		OurDoc->a_UserEnteredFunctions[index].Text = OurTabUserFunctions->a_UserEnteredFunctions[index].Text;
		OurDoc->a_UserEnteredFunctions[index].TotalArguments = OurTabUserFunctions->a_UserEnteredFunctions[index].TotalArguments;
		
		int argindex;
		for (argindex = 0; argindex < OurTabUserFunctions->a_UserEnteredFunctions[index].TotalArguments; argindex++)
		{
			OurDoc->a_UserEnteredFunctions[index].Arguments[argindex] = OurTabUserFunctions->a_UserEnteredFunctions[index].Arguments[argindex];
			OurDoc->a_UserEnteredFunctions[index].ArgumentTypes[argindex] = OurTabUserFunctions->a_UserEnteredFunctions[index].ArgumentTypes[argindex];
		}
	}
	// Get Check Value
	HTREEITEM EachItem;
	for (EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetChildItem(OurTabUserFunctions->UserFnRoot); EachItem != NULL; EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetNextItem(EachItem, TVGN_NEXT))
	{
		for (index = 0; index < OurTabUserFunctions->m_TotalUserEnteredFunctions; index++)
		{
			if (OurTabUserFunctions->c_UserFunctionSelection.GetItemText(EachItem) == OurTabUserFunctions->a_UserEnteredFunctions[index].Name &&
				OurTabUserFunctions->c_UserFunctionSelection.GetCheck(EachItem))
				break;
		}
		OurDoc->a_UserEnteredFunctions[index].Selected = (OurTabUserFunctions->c_UserFunctionSelection.GetCheck(EachItem) & 0x01);
	}

	// Store BuiltIns
	index = 0;
	OurDoc->m_TotalSelectedBuiltIns = 0;
	for (EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetChildItem(OurTabUserFunctions->BuiltInRoot); EachItem != NULL; EachItem = OurTabUserFunctions->c_UserFunctionSelection.GetNextItem(EachItem, TVGN_NEXT))
	{
		if (OurTabUserFunctions->c_UserFunctionSelection.GetCheck(EachItem))
		{
			OurDoc->a_SelectedBuiltIns[index++] = OurTabUserFunctions->c_UserFunctionSelection.GetItemText(EachItem);
			OurDoc->m_TotalSelectedBuiltIns++;
		}
	}

	// Store Base Program
	OurTabBaseProgram->c_BaseProgramEntryPanel.GetWindowText(OurDoc->m_BaseProgram);

	// Store Fitness Calculations
	OurTabFitnessCalc->c_RawFitnessFormula.GetWindowText(OurDoc->m_RawFitnessFormula);
	OurTabFitnessCalc->c_StandardizedFitnessFormula.GetWindowText(OurDoc->m_StandardizedFitnessFormula);

	// Store Attributes and Terminals Used
	for (index = 0; index < TOTALMAXATTRIBUTES; index++)
	{
		OurDoc->a_Attributes[index].Name = CString("");
		OurDoc->a_Attributes[index].Type = CString("");
		OurDoc->a_Attributes[index].IsPersistent = FALSE;
		OurDoc->a_Attributes[index].IsSelectable = FALSE;
	}

	OurDoc->m_TotalAttributes = OurTabAttributesAndTerms->c_AttributeList.GetItemCount();
	for (index = 0; index < OurTabAttributesAndTerms->c_AttributeList.GetItemCount(); index++)
	{
		OurDoc->a_Attributes[index].Name = OurTabAttributesAndTerms->c_AttributeList.GetItemText(index, 0);
		OurDoc->a_Attributes[index].Type = OurTabAttributesAndTerms->c_AttributeList.GetItemText(index, 1);
		OurDoc->a_Attributes[index].IsPersistent = (OurTabAttributesAndTerms->c_AttributeList.GetItemText(index, 2) == CString("TRUE") ? 1 : 0);
		OurDoc->a_Attributes[index].IsSelectable = (OurTabAttributesAndTerms->c_AttributeList.GetItemText(index, 3) == CString("TRUE") ? 1 : 0);
	}
	OurDoc->m_TermsSelectedAttributes  = (bool) (OurTabAttributesAndTerms->c_TerminalSelectionAttributes.GetCheck() & 0x01);
	OurDoc->m_TermsSelectedRandNums    = (bool) (OurTabAttributesAndTerms->c_TerminalSelectionNumerics.GetCheck() & 0x01);
	OurTabAttributesAndTerms->c_NumericTerminalPrecision.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedNumDecimals = atoi(GetVal);
	OurTabAttributesAndTerms->c_NumericTerminalLow.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedNumLow = atof(GetVal);
	OurTabAttributesAndTerms->c_NumericTerminalHigh.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedNumHigh = atof(GetVal);
	OurDoc->m_TermsSelectedBools       = (bool) (OurTabAttributesAndTerms->c_TerminalSelectionBooleans.GetCheck() & 0x01);
	OurDoc->m_TermsSelectedStrings     = (bool) (OurTabAttributesAndTerms->c_TerminalSelectionString.GetCheck() & 0x01);
	OurTabAttributesAndTerms->c_TermCharRangeLow.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedCharLow     = atoi (GetVal);
	OurTabAttributesAndTerms->c_TermCharRangeHigh.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedCharHigh     = atoi(GetVal);
	OurTabAttributesAndTerms->c_TermStringLengthLow.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedCharLenLow   = atoi(GetVal);
	OurTabAttributesAndTerms->c_TermStringLengthHigh.GetWindowText(GetVal);
	OurDoc->m_TermsSelectedCharLenHigh   = atoi(GetVal);
	OurDoc->m_TermsSelectedArgs        = (bool) (OurTabAttributesAndTerms->c_TerminalSelectionArgs.GetCheck() & 0x01);

}


void CEnvironmentFormView::OnExecute() 
{
	int index;
	int parmindex;

	UpdateDoc();

	if (RunTime != NULL)
	{
		delete RunTime;
		RunTime = NULL;
	}

	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	OurDoc->ResetTrees();

	//////////////////////////////////////////////////////////////////////////////////
	// Compile Base Program
	OurDoc->t_MainProgramTree = new class CGPProgram;
	if (!OurDoc->t_MainProgramTree->Compile(OurDoc->m_BaseProgram))
	{
		// Error in Compile of Base Program
		OurDoc->ResetTrees();
		AfxMessageBox("Base Program has errors.  Cannot execute");
		return;
	}

	//////////////////////////////////////////////////////////////////////////////////
	// Compile User Functions
	for (index = 0; index < OurDoc->m_TotalUserEnteredFunctions; index++)
	{
		enum RETURNTYPE SetType;
		if (OurDoc->a_UserEnteredFunctions[index].Type == CString("Number"))
			SetType = rtFLOAT;
		if (OurDoc->a_UserEnteredFunctions[index].Type == CString("Boolean"))
			SetType = rtBOOL;
		if (OurDoc->a_UserEnteredFunctions[index].Type  == CString("String"))
			SetType = rtSTRING;
		if (OurDoc->a_UserEnteredFunctions[index].Type  == CString("Void"))
			SetType = rtVOID;

		OurDoc->tbl_OurFunctionTable.AddFunction(OurDoc->a_UserEnteredFunctions[index].Name, SetType);
		for (parmindex = 0; parmindex < OurDoc->a_UserEnteredFunctions[index].TotalArguments; parmindex++)
		{
			if (OurDoc->a_UserEnteredFunctions[index].ArgumentTypes[parmindex] == CString("Number"))
				SetType = rtFLOAT;
			if (OurDoc->a_UserEnteredFunctions[index].ArgumentTypes[parmindex] == CString("Boolean"))
				SetType = rtBOOL;
			if (OurDoc->a_UserEnteredFunctions[index].ArgumentTypes[parmindex]  == CString("String"))
				SetType = rtSTRING;

			OurDoc->tbl_OurFunctionTable.AddParameter(OurDoc->a_UserEnteredFunctions[index].Name, OurDoc->a_UserEnteredFunctions[index].Arguments[parmindex], SetType);
		}
		if (!OurDoc->tbl_OurFunctionTable.Compile(OurDoc->a_UserEnteredFunctions[index].Name, OurDoc->a_UserEnteredFunctions[index].Text))
		{
			OurDoc->ResetTrees();
			AfxMessageBox(CString("Error while compiling function ") + OurDoc->a_UserEnteredFunctions[index].Name);
			return;
		}
		//////////////////////////////////////////////////////////////////////////////////
		// Build Function Selection Table for Random Function Selection During Generation
		if (OurDoc->a_UserEnteredFunctions[index].Selected)
			OurDoc->tbl_OurFunctionSelections.AddFunction(OurDoc->a_UserEnteredFunctions[index].Name);
	}

	//////////////////////////////////////////////////////////////////////////////////
	// Add to Selection Function Table all selected built-in functions
	for (index = 0; index < OurDoc->m_TotalSelectedBuiltIns; index++)
	{
		CString NameOnly;
		NameOnly = OurDoc->a_SelectedBuiltIns[index];
		NameOnly = NameOnly.Right(NameOnly.GetLength() - NameOnly.Find(" ", 0) - 1);
		OurDoc->tbl_OurFunctionSelections.AddFunction(NameOnly);
	}


	//////////////////////////////////////////////////////////////////////////////////
	// Check to ensure that all functions used are declared functions
	CGPProgram *CheckProgram;
	CSubTree   *CheckTree;
	for (index = 0; index < OurDoc->m_TotalUserEnteredFunctions; index++)
	{
		CheckProgram = OurDoc->tbl_OurFunctionTable.GetFunctionProgram(OurDoc->a_UserEnteredFunctions[index].Name);
		CheckTree = CheckProgram->ProgramTree;
		if (!CheckProgram->CheckLegalFunctions(CheckTree, &OurDoc->tbl_OurFunctionTable))
		{
			OurDoc->ResetTrees();
			AfxMessageBox(CString("Error - Some function call in ") + OurDoc->a_UserEnteredFunctions[index].Name + CString(" is undeclared in User Functions tab."));
			return;
		}
	}
	
	//////////////////////////////////////////////////////////////////////////////////
	// Check to ensure that base program function uses functions that are declared
	if (!OurDoc->t_MainProgramTree->CheckLegalFunctions(OurDoc->t_MainProgramTree->ProgramTree, &OurDoc->tbl_OurFunctionTable))
	{
		OurDoc->ResetTrees();
		AfxMessageBox(CString("Error - Some function call in base program is undeclared in User Functions tab."));
		return;
	}


	///////////////////////////////////////////////////////////////////////
	// Compile Fitness Calculations
	if (OurDoc->m_RawFitnessFormula.GetLength() == 0)
		OurDoc->m_RawFitnessFormula = CString("0");
	OurDoc->t_RawFitnessTree = new CGPProgram;
	if (!OurDoc->t_RawFitnessTree->Compile(OurDoc->m_RawFitnessFormula))
	{
		OurDoc->ResetTrees();
		AfxMessageBox("Could not compile Raw Fitness Formula");
		return;
	}
	
	if (OurDoc->m_StandardizedFitnessFormula.GetLength() == 0)
	{
		OurDoc->ResetTrees();
		AfxMessageBox("Must have a Standardized Fitness Formula.");
		return;
	}
	
	OurDoc->t_StdFitnessTree = new CGPProgram;
	if (!OurDoc->t_StdFitnessTree->Compile(OurDoc->m_StandardizedFitnessFormula))
	{
		OurDoc->ResetTrees();
		AfxMessageBox ("Could not compile Standardized Fitness Formula");
		return;
	}
	
	//////////////////////////////////////////////////////////////////////////////////
	// Find Result-Producing Branch to manipulate
	OurDoc->t_RPBNode.ProgramTree = OurDoc->t_MainProgramTree->FindRPB(OurDoc->t_MainProgramTree->ProgramTree);
	if (OurDoc->t_RPBNode.ProgramTree == NULL)
	{
		OurDoc->ResetTrees();
		AfxMessageBox ("Base Program has no RPB() call.  The RPB() call is the location where genetic function generation will take place.");

		return;
	}

	//////////////////////////////////////////////////////////////////////////////////
	// Determine context of the RPB block (to determine the context of the trees to grow)
	OurDoc->m_RPBContext = OurDoc->t_MainProgramTree->GetRPBContext(OurDoc->t_MainProgramTree->ProgramTree, &OurDoc->tbl_OurFunctionTable);
	if (OurDoc->m_RPBContext == rtRPBFOUND)
		OurDoc->m_RPBContext = rtVOID;

	if (OurDoc->m_RPBContext == rtERROR)
	{
		OurDoc->ResetTrees();
		AfxMessageBox ("Could not determine the context of the RPB block.");
		return;
	}

	
	//////////////////////////////////////////////////////////////////////////////////
	// Ensure that all attributes used in program and fitness trees have been declared
	// Add Arguments to the attribute table temporarily
	for (index = 0; index < 6; index++)
		OurDoc->a_Attributes[index + OurDoc->m_TotalAttributes++].Name.Format("Argument%d", index);
	if (!OurDoc->t_MainProgramTree->CheckUsedAttributes(OurDoc->t_MainProgramTree->ProgramTree, OurDoc->a_Attributes, OurDoc->m_TotalAttributes))
	{
		AfxMessageBox ("An attribute used in Base Program has not been declared");
		OurDoc->ResetTrees();
		return;
	}
	// Remove arguments from the attribute table
	OurDoc->m_TotalAttributes -= 6;

	// Node the little bit of jury-rigging done here -- artifically add 'Target' to
	// the environment's attribute table to check the Raw Fitness Tree
	OurDoc->a_Attributes[OurDoc->m_TotalAttributes++].Name = CString("Target");
	if (!OurDoc->t_RawFitnessTree->CheckUsedAttributes(OurDoc->t_RawFitnessTree->ProgramTree, OurDoc->a_Attributes, OurDoc->m_TotalAttributes))
	{
		AfxMessageBox ("An attribute used in Raw Fitness calculation has not been declared");
		OurDoc->ResetTrees();
		return;
	}

	// Continue the juryrigging; change it to Raw.
	OurDoc->a_Attributes[OurDoc->m_TotalAttributes-1].Name = CString("Raw");
	if (!OurDoc->t_StdFitnessTree->CheckUsedAttributes(OurDoc->t_StdFitnessTree->ProgramTree, OurDoc->a_Attributes, OurDoc->m_TotalAttributes))
	{
		AfxMessageBox ("An attribute used in Standard Fitness calculation has not been declared");
		OurDoc->ResetTrees();
		return;
	}

	// Undo juryrigging and return to standard state.
	OurDoc->a_Attributes[--OurDoc->m_TotalAttributes].Name = CString("");

	//////////////////////////////////////////////////////////////////////////////////
	// Ensure the entire environment is contextually sound:  
	// All functions used in random tree generation should have arguments
	// for whose type at least one other function is generated.  (I.e., if 
	// a selectable function requires a boolean argument, then at least one
	// boolean function/terminal needs to be selected.)
	if (!OurDoc->IsContextuallySound())
	{
		OurDoc->ResetTrees();
		AfxMessageBox ("The environment is not contextually sound.  At least one selected function or built-in statement selected requires a data type that is not returned by any function or is any terminal selected.");
		return;
	}
	
	//////////////////////////////////////////////////////////////////////////////////
	// Execute the Environment
	RunTime = new CGAPSExecution(OurDoc, GetDlgItem(IDC_OUTPUTWINDOW));
	if (RunTime->Launch())
	{

		//////////////////////////////////////////////////////////////////////////////////
		// Create Honor Roll Buttons
		HRButtonStart = 1;
		DoHonorRollButtons();

	}
	else
	{
		delete RunTime;
		RunTime = NULL;
	}
	
//	OurDoc->ResetTrees();

}

void CEnvironmentFormView::DoHonorRollButtons()
{

	if (RunTime == NULL)
		return;
	
	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();


	m_RightHRScroller.ShowWindow(OurDoc->m_HonorRollSize >= HRButtonStart + 5 ? SW_SHOW : SW_HIDE);
	m_LeftHRScroller.ShowWindow(HRButtonStart > 5 ? SW_SHOW : SW_HIDE);

	m_HonorRollBtn1.m_Fitness.Format("%1.4f", RunTime->HonorRoll[HRButtonStart-1].m_Fitness);
	m_HonorRollBtn1.ShowWindow(SW_SHOW);
	
	if (OurDoc->m_HonorRollSize - HRButtonStart > 0)
	{
		m_HonorRollBtn2.m_Fitness.Format("%1.4f", RunTime->HonorRoll[HRButtonStart].m_Fitness);
		m_HonorRollBtn2.ShowWindow(SW_SHOW);
	}
	else
		m_HonorRollBtn2.ShowWindow(SW_HIDE);
	if (OurDoc->m_HonorRollSize - HRButtonStart > 1)
	{
		m_HonorRollBtn3.m_Fitness.Format("%1.4f", RunTime->HonorRoll[HRButtonStart+1].m_Fitness);
		m_HonorRollBtn3.ShowWindow(SW_SHOW);
	}
	else
		m_HonorRollBtn3.ShowWindow(SW_HIDE);
	if (OurDoc->m_HonorRollSize - HRButtonStart > 2)
	{
		m_HonorRollBtn4.m_Fitness.Format("%1.4f", RunTime->HonorRoll[HRButtonStart+2].m_Fitness);
		m_HonorRollBtn4.ShowWindow(SW_SHOW);
	}
	else
		m_HonorRollBtn4.ShowWindow(SW_HIDE);
	if (OurDoc->m_HonorRollSize - HRButtonStart > 3)
	{
		m_HonorRollBtn5.m_Fitness.Format("%1.4f", RunTime->HonorRoll[HRButtonStart+3].m_Fitness);
		m_HonorRollBtn5.ShowWindow(SW_SHOW);
	}
	else
		m_HonorRollBtn5.ShowWindow(SW_HIDE);

	RedrawWindow();
}

void CEnvironmentFormView::LaunchOutWindow(int WhichButton)
{
	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();
	
	AfxInitRichEdit( );
	CString FormatIt;

	FormatIt.Format("ID = %d, Fitness = %1.4f", RunTime->HonorRoll[HRButtonStart-2 + WhichButton].ID, RunTime->HonorRoll[HRButtonStart-2 + WhichButton].m_Fitness);
	CDlgGAPSOutput * OurOutWindow;

	OurOutWindow = new CDlgGAPSOutput;
	OurOutWindow->Create(IDD_GAPSINDOUTPUT);
	OurOutWindow->SetHRMember(&RunTime->HonorRoll[HRButtonStart-2 + WhichButton]);
	OurOutWindow->SetHREnvironment(OurDoc);
	OurOutWindow->SetWindowText(FormatIt);
	OurOutWindow->ShowWindow(SW_SHOW); 

}

void CEnvironmentFormView::OnHonorroll1() 
{
	LaunchOutWindow(1);
}

void CEnvironmentFormView::OnHonorroll2() 
{
	LaunchOutWindow(2);
}

void CEnvironmentFormView::OnHonorroll3() 
{
	LaunchOutWindow(3);
}

void CEnvironmentFormView::OnHonorroll4() 
{
	LaunchOutWindow(4);
}

void CEnvironmentFormView::OnHonorroll5() 
{
	LaunchOutWindow(5);
}

void CEnvironmentFormView::OnLefthr() 
{
	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	if (HRButtonStart - 5 > 0)
	{
		HRButtonStart -= 5;
		DoHonorRollButtons();
	}
	

}

void CEnvironmentFormView::OnRighthr2() 
{
	CEnvironmentDoc *OurDoc;
	OurDoc = GetDocument();

	if (HRButtonStart + 4 < OurDoc->m_HonorRollSize)
	{
		HRButtonStart += 5;
		DoHonorRollButtons();
	}


}


void CEnvironmentFormView::OnTbpauseexec() 
{
	
}

void CEnvironmentFormView::OnTbstopexec() 
{
	if (RunTime != NULL)
	{
		if (AfxMessageBox("Really halt the execution?", MB_YESNO) == IDYES)
		{

			RunTime->Stopped = TRUE;
		}
	}
}
