#include "MyTabCtrl.h"
#include "TabIdentification.h"
#include "TabTargets.h"
#include "TabGeneralParms.h"
#include "TabMatchCriteria.h"
#include "TabFitnessCalc.h"
#include "TabUserFunctions.h"
#include "TabBaseProgram.h"
#include "TabAttributesAndTerms.h"

#include "EnvironmentDoc.h"
#include "CGAPSExecution.h"
#include "GAPSHRButton.h"

#if !defined(AFX_ENVIRONMENTFORMVIEW_H__96942A6C_AA1A_4A4A_B592_FFDE6E16F3DF__INCLUDED_)
#define AFX_ENVIRONMENTFORMVIEW_H__96942A6C_AA1A_4A4A_B592_FFDE6E16F3DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnvironmentFormView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEnvironmentFormView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CEnvironmentFormView : public CFormView
{
protected:
	CEnvironmentFormView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEnvironmentFormView)

// Form Data
public:
	//{{AFX_DATA(CEnvironmentFormView)
	enum { IDD = IDD_ENVIRONFORM };
	CButton	m_RightHRScroller;
	CButton	m_LeftHRScroller;
	GAPSHRButton	m_HonorRollBtn5;
	GAPSHRButton	m_HonorRollBtn4;
	GAPSHRButton	m_HonorRollBtn3;
	GAPSHRButton	m_HonorRollBtn2;
	GAPSHRButton	m_HonorRollBtn1;
	CStatic	m_OutputWindow;
	CMyTabCtrl	m_TabExecutionParms;
	CTreeCtrl	m_LibsAndFuncs;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	CEnvironmentDoc* GetDocument();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEnvironmentFormView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CEnvironmentFormView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEnvironmentFormView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnExecute();
	afx_msg void OnHonorroll1();
	afx_msg void OnHonorroll2();
	afx_msg void OnHonorroll3();
	afx_msg void OnHonorroll4();
	afx_msg void OnHonorroll5();
	afx_msg void OnLefthr();
	afx_msg void OnRighthr2();
	afx_msg void OnTbpauseexec();
	afx_msg void OnTbstopexec();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public: 
	CTabIdentification *OurTabIdent;
	CTabGeneralParms *OurTabGenParms;
	CTabTargets *OurTabTargets;
	CTabFitnessCalc *OurTabFitnessCalc;
	CTabUserFunctions *OurTabUserFunctions;
	CTabBaseProgram *OurTabBaseProgram;
	CTabAttributesAndTerms *OurTabAttributesAndTerms;

	CGAPSExecution * RunTime;

	void UpdateDoc();
	int HRButtonStart;
	void DoHonorRollButtons();
	void LaunchOutWindow(int WhichButton);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENVIRONMENTFORMVIEW_H__96942A6C_AA1A_4A4A_B592_FFDE6E16F3DF__INCLUDED_)
