// GAPS2.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GAPS2.h"

#include "MainFrm.h"

#include "EnvironmentDoc.h"
#include "EnvironmentFrame.h"
#include "EnvironmentFormView.h"

#include "DlgStartupPage.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define GAPSSTARTPOSX 150
#define GAPSSTARTPOSY 100

/////////////////////////////////////////////////////////////////////////////
// CGAPS2App

BEGIN_MESSAGE_MAP(CGAPS2App, CWinApp)
	//{{AFX_MSG_MAP(CGAPS2App)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW_ENV, OnFileNewEnv)
	ON_COMMAND(ID_FILE_OPEN_ENV, OnFileOpenEnv)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)

	// GAPS2-Specific Executors
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGAPS2App construction

CGAPS2App::CGAPS2App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGAPS2App object

CGAPS2App theApp;

/////////////////////////////////////////////////////////////////////////////
// CGAPS2App initialization

BOOL CGAPS2App::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Genetic Programming Laboratory"));

	LoadStdProfileSettings(5);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pEnvironmentTemplate;
	pEnvironmentTemplate = new CMultiDocTemplate(
		IDR_ENVIRONMENT,
		RUNTIME_CLASS(CEnvironmentDoc),
		RUNTIME_CLASS(CEnvironmentFrame),
		RUNTIME_CLASS(CEnvironmentFormView));
	AddDocTemplate(pEnvironmentTemplate); 

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;


	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();


	OurStartupPage = new CDlgStartupPage;
	OurStartupPage->Create(IDD_STARTUPDLG);
	CRect StartupRect;
	OurStartupPage->GetWindowRect(StartupRect);

	OurStartupPage->MoveWindow(CRect(GAPSSTARTPOSX, GAPSSTARTPOSY, GAPSSTARTPOSX+612, GAPSSTARTPOSY+410));
	OurStartupPage->ShowWindow(SW_SHOW);
	
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CGAPS2App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CGAPS2App message handlers




void CGAPS2App::OnFileNewEnv() 
{

	POSITION curTemplatePos = GetFirstDocTemplatePosition();

	while (curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			GetNextDocTemplate(curTemplatePos);
		CString Getstr;

		curTemplate->GetDocString(Getstr, CDocTemplate::docName);
		if (Getstr == _T("Environment"))
		{
			OurStartupPage->ShowWindow(SW_HIDE);
			curTemplate->OpenDocumentFile(NULL);
			return;
		}
	}
	
}


void CGAPS2App::OnFileOpenEnv() 
{
	POSITION curTemplatePos = GetFirstDocTemplatePosition();

	while (curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			GetNextDocTemplate(curTemplatePos);
		CString Getstr;

		curTemplate->GetDocString(Getstr, CDocTemplate::docName);
		if (Getstr == _T("Environment"))
		{
			static char BASED_CODE szFilter[] = "GAPS2 Environment Files (*.gps)|*.gps";

			// Create File Open Dialog
			CFileDialog OurFileDlg (
				TRUE,                // Open
				_T(".gps"),           // Default GP-Lab File
				_T("*.gps"),       // Default GP-Lab Library File Name
				OFN_HIDEREADONLY,     // Hide read-only files
				szFilter);

			if (OurFileDlg.DoModal() == IDOK)
			{
				OurStartupPage->ShowWindow(SW_HIDE);
				curTemplate->OpenDocumentFile(OurFileDlg.GetPathName());
				return;
			}
		}
	}
}


BOOL CheckAfxMessages()
{

	MSG msg;
	if ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) ) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return TRUE;
}


CDocument* CGAPS2App::OpenDocumentFile(LPCTSTR lpszFileName) 
{
	// TODO: Add your specialized code here and/or call the base class
	OurStartupPage->ShowWindow(SW_HIDE);

	return CWinApp::OpenDocumentFile(lpszFileName);
}
