// GAPS2.h : main header file for the GAPS2 application
//

#if !defined(AFX_GAPS2_H__8A4AC830_9790_476C_8DD7_8FF1A494A5C7__INCLUDED_)
#define AFX_GAPS2_H__8A4AC830_9790_476C_8DD7_8FF1A494A5C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CGAPS2App:
// See GAPS2.cpp for the implementation of this class
//

class CGAPS2App : public CWinApp
{
public:
	CGAPS2App();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGAPS2App)
	public:
	virtual BOOL InitInstance();
	virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName);
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CGAPS2App)
	afx_msg void OnAppAbout();
	afx_msg void OnFileNewEnv();
	afx_msg void OnFileOpenEnv();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


	class CDlgStartupPage *OurStartupPage;
};

BOOL CheckAfxMessages();

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GAPS2_H__8A4AC830_9790_476C_8DD7_8FF1A494A5C7__INCLUDED_)


enum RETURNTYPE {rtFLOAT, rtBOOL, rtSTRING, rtVOID, rtERROR, rtEXPRESSION, rtATTRIBUTE, rtRPBFOUND};


struct UserEnteredFunction {
	CString Name;
	CString Text;
	CString Type;
	bool Selected;
	CString Arguments[6];
	CString ArgumentTypes[6];
	int TotalArguments;
};

struct ArgsAndTargets {
	CString Arg1;
	CString Arg2;
	CString Arg3;
	CString Arg4;
	CString Arg5;
	CString Arg6;
	CString TargetVal;
	enum RETURNTYPE Arg1Type;
	enum RETURNTYPE Arg2Type;
	enum RETURNTYPE Arg3Type;
	enum RETURNTYPE Arg4Type;
	enum RETURNTYPE Arg5Type;
	enum RETURNTYPE Arg6Type;
	enum RETURNTYPE TargetType;
	struct ArgsAndTargets *next;
};

struct UserAttributes {
	CString Name;
	CString Type;
	bool IsPersistent;
	bool IsSelectable;
};

// Serialization Word bytes.  
// This enumaration is to allow a serialization of an Environment (i.e., the 
// loading and saving to/from disk) to be in any format and to allow for
// new environment types, etc.
enum ENVIRONSER {es_ENDENVIRONMENT, es_ENVIRONNAME, es_ENVIRONDESCR,
				 es_MUTATIONRATE, es_MAXUNPRODUCTIVEGENS, es_SHRINKAGEGENS,
				 es_POPULATION, es_HONORROLLSIZE, es_ABSOLUTETIMELIMIT,
				 es_FITNESSTHRESHOLD, es_GENERATIONSTRATEGY, es_MINIMUMDEPTH,
				 es_MAXIMUMDEPTH, es_SELECTIONSTRATEGY, es_SELECTIONPARAMETER,
				 es_TOURNAMENTSIZE, es_NUMBEROFARGUMENTS, 
				 es_NUMBEROFTARGETS, es_TARGETLIST, es_USERFUNCTIONS, es_NUMBEROFUSRFUNCTS,
				 es_BASEPROGRAM, es_RAWFITNESSFORMULA, es_STANDARDFITNESSFORMULA, 
				 es_SELECTEDBUILTINS, es_TOTALATTRIBUTES, es_ATTRIBUTES, 
				 es_SELECTIONATTRIBUTES, es_SELECTIONRANDONNUMS, es_SELECTIONNUMDECIMALS,
				 es_SELECTIONNUMLOW, es_SELECTIONNUMHIGH, es_SELECTIONBOOLEANS,
				 es_SELECTIONSTRINGS, es_SELECTIONCHARSLOW, es_SELECTIONCHARSHIGH,
				 es_SELECTIONSTRLENLOW, es_SELECTIONSTRLENHIGH, es_SELECTIONARGS
				 };


enum EXECUTIONMODE {xm_GENESIS, xm_NORMAL, xm_SHRINKAGE};