/////////////////////////////////////////
// CFunction Implemenation File
/////////////////////////////////////////

#include "stdafx.h"
#include "CToken.h"
#include "CSubTree.h"

bool IsDigits(CString & InPiece);
bool IsNumber(CString & TestStr );
bool IsAttribute(CString & TestStr);
bool IsFunctionForm(CString &TestStr);
int  IsBoolean(CString &TestStr);

bool IsNumber(CString & TestStr)
{
	CString InStringN;
	InStringN = TestStr;

	//       N -> D.D
	int FoundLoc;
	if (InStringN.Find(".") > -1 &&
		InStringN.Find("e") == -1)
	{
		int DecLoc;
		DecLoc = InStringN.Find(".");
		if (IsDigits(InStringN.Left(DecLoc)) &&
			IsDigits(InStringN.Right(InStringN.GetLength() - DecLoc - 1)))
			return TRUE;
	}

	//       N -> D.DeD
	//       N -> D.De-D
	if ((FoundLoc = InStringN.Find(".")) > -1 &&
		 InStringN.Find("e") > FoundLoc)
	{

		int ELoc;
		int NELoc;
		CString WholePart;
		CString Fraction;
		CString Mantissa;

		NELoc = InStringN.Find("e-");
		if (NELoc == -1)
			ELoc = InStringN.Find("e");

		WholePart = InStringN.Left(FoundLoc);
		Fraction = InStringN.Mid(FoundLoc+1, (ELoc > -1 ? ELoc : NELoc) - FoundLoc - 1);
		Mantissa = InStringN.Right(InStringN.GetLength() - (ELoc > -1 ? ELoc  : NELoc + 1 ) - 1);
		
		if (IsDigits(WholePart) && IsDigits(Fraction) && IsDigits(Mantissa))
			return TRUE;
	}

	// N->D
	if (IsDigits(InStringN))
		return TRUE;

	return FALSE;
}

bool IsDigits(CString & InPiece)
{
	//       D -> dD | {NULL}
	int index;

	if (InPiece.GetLength() == 0)
		return FALSE;

	CString AllParts;
	AllParts = "0123456789";
	for (index = 0; index < InPiece.GetLength(); index++)
	{
		if (AllParts.Find(InPiece.Mid(index, 1), 0) == -1)
			return FALSE;
	}
	return TRUE;
}

bool IsAttribute(CString & TestStr)
{
	int index;

	if (TestStr.GetAt(0) != '&')
		return FALSE;
	
	for (index = 1; index < TestStr.GetLength(); index++)
		if (!(TestStr.GetAt(index) >= '0' && TestStr.GetAt(index) <= '9' ||
			TestStr.GetAt(index) >= 'a' && TestStr.GetAt(index) <= 'z' ||
			TestStr.GetAt(index) >= 'A' && TestStr.GetAt(index) <= 'Z'))
			return FALSE;

	return TRUE;
}

bool IsFunctionForm(CString &TestStr)
{
	int index;

	if (!((TestStr.GetAt(0) >= 'A' &&  TestStr.GetAt(0) <= 'Z') ||
		  (TestStr.GetAt(0) >= 'a' &&  TestStr.GetAt(0) <= 'z')))
		return FALSE;
	
	for (index = 1; index < TestStr.GetLength(); index++)
		if (!(TestStr.GetAt(index) >= '0' && TestStr.GetAt(index) <= '9' ||
			TestStr.GetAt(index) >= 'a' && TestStr.GetAt(index) <= 'z' ||
			TestStr.GetAt(index) >= 'A' && TestStr.GetAt(index) <= 'Z'))
			return FALSE;

	return TRUE;

}

int IsBoolean(CString &TestStr)
{
	if (TestStr == CString("TRUE") ||
		TestStr == CString("T") ||
		TestStr == CString("1") ||
		TestStr == CString("YES") ||
		TestStr == CString("Y"))
		return 1;

	if (TestStr == CString("FALSE") ||
		TestStr == CString("F") ||
		TestStr == CString("0") ||
		TestStr == CString("NO") ||
		TestStr == CString("N"))
		return 0;

	return -1;
}