// TabAttributesAndTerms.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"
#include "TabAttributesAndTerms.h"
#include "MyListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabAttributesAndTerms dialog


CTabAttributesAndTerms::CTabAttributesAndTerms(CWnd* pParent /*=NULL*/)
	: CDialog(CTabAttributesAndTerms::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabAttributesAndTerms)
	m_TerminalCharStringOutput = _T("");
	//}}AFX_DATA_INIT
}


void CTabAttributesAndTerms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabAttributesAndTerms)
	DDX_Control(pDX, IDC_ADDATTRIBUTEBTN, c_StoreAttributeBtn);
	DDX_Control(pDX, IDC_SELECTABLE, c_AttributeSelectable);
	DDX_Control(pDX, IDC_ATTRPERSISTENT, c_AttributePersistent);
	DDX_Control(pDX, IDC_TERMSELARGS, c_TerminalSelectionArgs);
	DDX_Control(pDX, IDC_CHARRANGELOW, c_TermCharRangeLow);
	DDX_Control(pDX, IDC_CHARRANGEHIGH, c_TermCharRangeHigh);
	DDX_Control(pDX, IDC_TERMSELCHAR, c_TerminalSelectionString);
	DDX_Control(pDX, IDC_STRINGLENGTHLOW, c_TermStringLengthLow);
	DDX_Control(pDX, IDC_STRINGLENGTHHIGH, c_TermStringLengthHigh);
	DDX_Control(pDX, IDC_NUMERICLOW, c_NumericTerminalLow);
	DDX_Control(pDX, IDC_NUMERICHIGH, c_NumericTerminalHigh);
	DDX_Control(pDX, IDC_NUMERICCONSTPREC, c_NumericTerminalPrecision);
	DDX_Control(pDX, IDC_TERMSELNUMERICS, c_TerminalSelectionNumerics);
	DDX_Control(pDX, IDC_TERMSELBOOL, c_TerminalSelectionBooleans);
	DDX_Control(pDX, IDC_TERMSELATTRIBS, c_TerminalSelectionAttributes);
	DDX_Control(pDX, IDC_ATTRIBLIST, c_AttributeList);
	DDX_Control(pDX, IDC_ATTRTYPESELECT, c_AttributeType);
	DDX_Control(pDX, IDC_ATTRIBNAME, c_AttributeName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabAttributesAndTerms, CDialog)
	//{{AFX_MSG_MAP(CTabAttributesAndTerms)
	ON_BN_CLICKED(IDC_ADDATTRIBUTEBTN, OnAddattributebtn)
	ON_BN_CLICKED(IDC_TERMSELNUMERICS, OnTermselnumerics)
	ON_BN_CLICKED(IDC_TERMSELCHAR, OnTermselchar)
	ON_BN_CLICKED(IDC_RMVATTRIBUTEBTN, OnRmvattributebtn)
	ON_NOTIFY(NM_CLICK, IDC_ATTRIBLIST, OnClickAttriblist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabAttributesAndTerms message handlers

void CTabAttributesAndTerms::OnAddattributebtn() 
{
	// Check to see if it already exists in the Attribute List
	int index;
	CString AddingAttrName;
	CString AddingAttrType;
	int AddingAttrPersistent;
	int AddingAttrSelectable;

	c_AttributeName.GetWindowText(AddingAttrName);
	c_AttributeType.GetWindowText(AddingAttrType);
	AddingAttrPersistent = c_AttributePersistent.GetCheck();
	AddingAttrSelectable = c_AttributeSelectable.GetCheck();

	for (index = 0; index < c_AttributeList.GetItemCount(); index++)
	{
		if (c_AttributeList.GetItemText(index, 0) == AddingAttrName)
			break;
	}
	if (index == c_AttributeList.GetItemCount())
	{
		index = c_AttributeList.InsertItem(c_AttributeList.GetItemCount(), "");
	}

	c_AttributeList.SetItemText(index, 0, AddingAttrName);
	c_AttributeList.SetItemText(index, 1, AddingAttrType);
	c_AttributeList.SetItemText(index, 2, (AddingAttrPersistent == 0 ? CString("FALSE") : CString("TRUE")));
	c_AttributeList.SetItemText(index, 3, (AddingAttrSelectable == 0 ? CString("FALSE") : CString("TRUE")));

	c_StoreAttributeBtn.SetWindowText("Add");
}

void CTabAttributesAndTerms::OnRmvattributebtn() 
{
	if (c_AttributeList.GetSelectedCount() == 0)
		return;

	c_AttributeList.DeleteItem(c_AttributeList.GetSelectionMark());
	c_AttributeName.SetWindowText("");
	c_AttributeType.SetWindowText("");
	c_AttributePersistent.SetCheck(0);
	c_AttributeSelectable.SetCheck(0);
	
	c_StoreAttributeBtn.SetWindowText("Add");
}

void CTabAttributesAndTerms::OnClickAttriblist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	c_AttributeName.SetWindowText(c_AttributeList.GetItemText(c_AttributeList.GetSelectionMark(), 0));
	c_AttributeType.SetWindowText(c_AttributeList.GetItemText(c_AttributeList.GetSelectionMark(), 1));
	c_AttributePersistent.SetCheck(c_AttributeList.GetItemText(c_AttributeList.GetSelectionMark(), 2) == CString("TRUE") ? 1 : 0);
	c_AttributeSelectable.SetCheck(c_AttributeList.GetItemText(c_AttributeList.GetSelectionMark(), 3) == CString("TRUE") ? 1 : 0);

	if (c_AttributeList.GetSelectedCount() == 0)
		c_StoreAttributeBtn.SetWindowText("Add");
	else
		c_StoreAttributeBtn.SetWindowText("Update");
	
	*pResult = 0;
}


BOOL CTabAttributesAndTerms::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	c_TerminalSelectionArgs.SetCheck(TRUE);
	c_TerminalSelectionAttributes.SetCheck(TRUE);

	c_NumericTerminalHigh.EnableWindow(FALSE);
	c_NumericTerminalLow.EnableWindow(FALSE);
	c_NumericTerminalPrecision.EnableWindow(FALSE);
	c_TermStringLengthLow.EnableWindow(FALSE);
	c_TermStringLengthHigh.EnableWindow(FALSE);
	c_TermCharRangeLow.EnableWindow(FALSE);
	c_TermCharRangeHigh.EnableWindow(FALSE);

	c_AttributeList.InsertColumn(0, "Name", LVCFMT_LEFT, 100);
	c_AttributeList.InsertColumn(1, "Type", LVCFMT_LEFT, 60);
	c_AttributeList.InsertColumn(2, "Prsts", LVCFMT_LEFT, 50);
	c_AttributeList.InsertColumn(3, "Select", LVCFMT_LEFT, 50);

	c_AttributeList.SetHighlightType(CMyListCtrl::HIGHLIGHT_ROW);	
	
	c_StoreAttributeBtn.SetWindowText("Add");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTabAttributesAndTerms::OnTermselnumerics() 
{
	int CheckVal;
	CheckVal = c_TerminalSelectionNumerics.GetCheck();
	c_NumericTerminalHigh.EnableWindow(CheckVal);
	c_NumericTerminalLow.EnableWindow(CheckVal);
	c_NumericTerminalPrecision.EnableWindow(CheckVal);
}

void CTabAttributesAndTerms::OnTermselchar() 
{
	int CheckVal;
	CheckVal = c_TerminalSelectionString.GetCheck();

	c_TermStringLengthLow.EnableWindow(CheckVal);
	c_TermStringLengthHigh.EnableWindow(CheckVal);
	c_TermCharRangeLow.EnableWindow(CheckVal);
	c_TermCharRangeHigh.EnableWindow(CheckVal);
}

