// TabGeneralParms.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"
#include "TabGeneralParms.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabGeneralParms dialog


CTabGeneralParms::CTabGeneralParms(CWnd* pParent /*=NULL*/)
	: CDialog(CTabGeneralParms::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabGeneralParms)
	//}}AFX_DATA_INIT
}


void CTabGeneralParms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabGeneralParms)
	DDX_Control(pDX, IDC_ADDLSHRINKAGEGENS, c_ShrinkageGenerations);
	DDX_Control(pDX, IDC_SELSTRATSLIDER, c_SelectionStratSlider);
	DDX_Control(pDX, IDC_SELSTRAT_TOURN, c_SelectionStratTourn);
	DDX_Control(pDX, IDC_SELSTRAT_OVER, c_SelectionStratOver);
	DDX_Control(pDX, IDC_SELSTRAT_FITNESS, c_SelectionStratFit);
	DDX_Control(pDX, IDC_SELPARMTEXT, c_SelectionParmText);
	DDX_Control(pDX, IDC_SELPARMNUM, c_SelectionParmNum);
	DDX_Control(pDX, IDC_MINDEPTHTEXT, c_MinDepthText);
	DDX_Control(pDX, IDC_MINDEPTH, c_MinDepth);
	DDX_Control(pDX, IDC_MAXDEPTHTEXT, c_MaxDepthText);
	DDX_Control(pDX, IDC_MAXDEPTH, c_MaxDepth);
	DDX_Control(pDX, IDC_GENSEL_HALF, c_GenStratHalf);
	DDX_Control(pDX, IDC_GENSEL_GROW, c_GenStratGrow);
	DDX_Control(pDX, IDC_GENSEL_FULL, c_GenStratFull);
	DDX_Control(pDX, IDC_FITNESSTHRESHOLD, c_FitnessThreshold);
	DDX_Control(pDX, IDC_TIMELIMIT, c_AbsoluteTimeLimit);
	DDX_Control(pDX, IDC_HONORROLLSIZE, c_HonorRollSize);
	DDX_Control(pDX, IDC_POPULATION, c_InitialPopulation);
	DDX_Control(pDX, IDC_MAXUNPRODUCTIVE, c_MaxUnproductiveGens);
	DDX_Control(pDX, IDC_MUTATIONRATE, c_MutationRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabGeneralParms, CDialog)
	//{{AFX_MSG_MAP(CTabGeneralParms)
	ON_BN_CLICKED(IDC_GENSEL_GROW, OnGenselGrow)
	ON_BN_CLICKED(IDC_GENSEL_FULL, OnGenselFull)
	ON_BN_CLICKED(IDC_GENSEL_HALF, OnGenselHalf)
	ON_BN_CLICKED(IDC_SELSTRAT_FITNESS, OnSelstratFitness)
	ON_BN_CLICKED(IDC_SELSTRAT_TOURN, OnSelstratTourn)
	ON_BN_CLICKED(IDC_SELSTRAT_OVER, OnSelstratOver)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SELSTRATSLIDER, OnReleasedcaptureSelstratslider)
	ON_EN_KILLFOCUS(IDC_MAXDEPTH, OnKillfocusMaxdepth)
	ON_EN_KILLFOCUS(IDC_MINDEPTH, OnKillfocusMindepth)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabGeneralParms message handlers

void CTabGeneralParms::OnGenselGrow() 
{
	// IDC_GENSEL_GROW
	// BST_UNCHECKED
	// BST_CHECKED
	c_GenStratGrow.SetCheck(1);
	c_GenStratFull.SetCheck(0);
	c_GenStratHalf.SetCheck(0);

	c_MinDepth.EnableWindow(TRUE);
}

void CTabGeneralParms::OnGenselFull() 
{
	// IDC_GENSEL_FULL
	c_GenStratGrow.SetCheck(0);
	c_GenStratFull.SetCheck(1);
	c_GenStratHalf.SetCheck(0);

	c_MinDepthText.EnableWindow(FALSE);
	c_MinDepth.EnableWindow(FALSE);

}

void CTabGeneralParms::OnGenselHalf() 
{
	// IDC_GENSEL_HALF
	c_GenStratGrow.SetCheck(0);
	c_GenStratFull.SetCheck(0);
	c_GenStratHalf.SetCheck(1);

	c_MinDepthText.EnableWindow(TRUE);
	c_MinDepth.EnableWindow(TRUE);
}

void CTabGeneralParms::OnSelstratFitness() 
{
	// IDC_SELSTRAT_FITNESS
	c_SelectionStratFit.SetCheck(1);
	c_SelectionStratOver.SetCheck(0);
	c_SelectionStratTourn.SetCheck(0);

	c_SelectionStratSlider.EnableWindow(FALSE);
	c_SelectionParmText.EnableWindow(FALSE);
	c_SelectionParmNum.EnableWindow(FALSE);
	c_SelectionParmText.SetWindowText("");

}

void CTabGeneralParms::OnSelstratOver() 
{
	// IDC_SELSTRAT_OVER
	c_SelectionStratFit.SetCheck(0);
	c_SelectionStratOver.SetCheck(1);
	c_SelectionStratTourn.SetCheck(0);

	c_SelectionStratSlider.EnableWindow(TRUE);
	c_SelectionParmText.EnableWindow(TRUE);
	c_SelectionParmNum.EnableWindow(FALSE);

	m_GroupIISelPC = (double) c_SelectionStratSlider.GetPos() / 10;
	m_GroupISelPC = (double) 100.0 - m_GroupIISelPC;

	CString FormatIt;
	FormatIt.Format("Group I: %3.1f%c, Group II: %3.1f%c", m_GroupISelPC, '%', m_GroupIISelPC, '%');
	c_SelectionParmText.SetWindowText(FormatIt);

}

void CTabGeneralParms::OnSelstratTourn() 
{
	// IDC_SELSTRAT_TOURN
	c_SelectionStratFit.SetCheck(0);
	c_SelectionStratOver.SetCheck(0);
	c_SelectionStratTourn.SetCheck(1);

	c_SelectionStratSlider.EnableWindow(FALSE);
	c_SelectionParmText.EnableWindow(TRUE);
	c_SelectionParmText.SetWindowText("Tournament Selection Size:");
	c_SelectionParmNum.EnableWindow(TRUE);

}

void CTabGeneralParms::OnReleasedcaptureSelstratslider(NMHDR* pNMHDR, LRESULT* pResult) 
{

	m_GroupISelPC = ((double) c_SelectionStratSlider.GetPos() / (double) c_SelectionStratSlider.GetRangeMax()) * 100;
	m_GroupIISelPC = 100.0 - m_GroupISelPC;

	CString FormatIt;
	FormatIt.Format("I: top %3.1f%c fitness-wise; II: remaining %3.1f%c", m_GroupISelPC, '%', m_GroupIISelPC, '%');
	c_SelectionParmText.SetWindowText(FormatIt);

	*pResult = 0;
}

BOOL CTabGeneralParms::OnInitDialog() 
{
	CDialog::OnInitDialog();


	c_MaxDepth.SetWindowText(CString("2"));
	c_MinDepth.SetWindowText(CString("2"));

	// Selection Strategies Initialization
	c_SelectionStratSlider.EnableWindow(FALSE);
	c_SelectionParmText.EnableWindow(FALSE);
	c_SelectionParmNum.EnableWindow(FALSE);

	c_GenStratGrow.SetCheck(1);
	c_SelectionStratFit.SetCheck(1);

	m_GroupISelPC = 20.0;
	m_GroupIISelPC =80.0;

	c_SelectionStratSlider.SetRangeMin(0);
	c_SelectionStratSlider.SetRangeMax(1000);

	c_SelectionStratSlider.SetPos(200);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CTabGeneralParms::OnKillfocusMaxdepth() 
{
	CString GetMin;
	CString GetMax;
	
	c_MaxDepth.GetWindowText(GetMax);
	c_MinDepth.GetWindowText(GetMin);

	if (atoi(GetMax) < 2)
	{
		AfxMessageBox("Depth cannot be less than two.");
		c_MaxDepth.SetWindowText(CString("2"));
		c_MaxDepth.SetFocus();
	}

	if (atoi(GetMax) < atoi(GetMin))
	{
		AfxMessageBox("Maximum Depth cannot be less than minimum depth");
		c_MaxDepth.SetWindowText(GetMin);
		c_MaxDepth.SetFocus();
	}

	
}

void CTabGeneralParms::OnKillfocusMindepth() 
{
	CString GetMin;
	CString GetMax;
	
	c_MaxDepth.GetWindowText(GetMax);
	c_MinDepth.GetWindowText(GetMin);

	if (atoi(GetMin) < 2)
	{
		AfxMessageBox("Depth cannot be less than two.");
		c_MinDepth.SetWindowText(CString("2"));
		c_MinDepth.SetFocus();
	}

	if (atoi(GetMax) < atoi(GetMin))
	{
		AfxMessageBox("Minimum Depth cannot be greater than maximum depth");
		c_MaxDepth.SetWindowText(GetMax);
		c_MinDepth.SetFocus();
	}
	
}
