// TabMatchCriteria.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"
#include "TabMatchCriteria.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabMatchCriteria dialog


CTabMatchCriteria::CTabMatchCriteria(CWnd* pParent /*=NULL*/)
	: CDialog(CTabMatchCriteria::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabMatchCriteria)
	m_ClosePercentText = _T("");
	m_MatchPercentText = _T("");
	m_ThresholdValue = _T("");
	m_Match100Percent = FALSE;
	//}}AFX_DATA_INIT
}


void CTabMatchCriteria::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabMatchCriteria)
	DDX_Control(pDX, IDC_FITNESSWEIGHT, m_FitnessWeightSlider);
	DDX_Text(pDX, IDC_CLOSEPERCENT, m_ClosePercentText);
	DDX_Text(pDX, IDC_MATCHPERCENT, m_MatchPercentText);
	DDX_Text(pDX, IDC_THRESHOLD, m_ThresholdValue);
	DDX_Check(pDX, IDC_MATCH100, m_Match100Percent);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabMatchCriteria, CDialog)
	//{{AFX_MSG_MAP(CTabMatchCriteria)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_FITNESSWEIGHT, OnReleasedcaptureFitnessweight)
	ON_EN_CHANGE(IDC_MATCHPERCENT, OnChangeMatchpercent)
	ON_EN_CHANGE(IDC_CLOSEPERCENT, OnChangeClosepercent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabMatchCriteria message handlers

void CTabMatchCriteria::OnReleasedcaptureFitnessweight(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(TRUE);
	MatchPercent = (float) m_FitnessWeightSlider.GetPos() / 100;
	m_MatchPercentText.Format("%2.2f%c", MatchPercent, '%');
	m_ClosePercentText.Format("%2.2f%c", 100.0 - MatchPercent, '%');
	UpdateData(FALSE);
	*pResult = 0;
}

BOOL CTabMatchCriteria::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_FitnessWeightSlider.SetRange(0, 10000);
	m_FitnessWeightSlider.SetPos(5000);

	MatchPercent = (float) m_FitnessWeightSlider.GetPos() / 100;
	m_MatchPercentText.Format("%2.2f%c", MatchPercent, '%');
	m_ClosePercentText.Format("%2.2f%c", 100.0 - MatchPercent, '%');
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CTabMatchCriteria::OnChangeMatchpercent() 
{
	UpdateData(TRUE);
	CString Actual;

	Actual = m_MatchPercentText;
	Actual.TrimRight("%");
	m_ClosePercentText.Format("%2.2f%c", 100.0 - atof(Actual), '%');
	UpdateData(FALSE);
}

void CTabMatchCriteria::OnChangeClosepercent() 
{
	UpdateData(TRUE);
	CString Actual;

	Actual = m_ClosePercentText;
	Actual.TrimRight("%");
	m_MatchPercentText.Format("%2.2f%c", 100.0 - atof(Actual), '%');
	UpdateData(FALSE);
	
}
