// TabTargets.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"
#include "MyListCtrl.h"
#include "TabTargets.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabTargets dialog


CTabTargets::CTabTargets(CWnd* pParent /*=NULL*/)
	: CDialog(CTabTargets::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabTargets)
	m_TargetType = _T("");
	//}}AFX_DATA_INIT
}


void CTabTargets::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabTargets)
	DDX_Control(pDX, IDC_TARGETTYPE, c_TargetType);
	DDX_Control(pDX, IDC_ARGTYPE6, c_Argument6Type);
	DDX_Control(pDX, IDC_ARGTYPE5, c_Argument5Type);
	DDX_Control(pDX, IDC_ARGTYPE4, c_Argument4Type);
	DDX_Control(pDX, IDC_ARGTYPE3, c_Argument3Type);
	DDX_Control(pDX, IDC_ARGTYPE2, c_Argument2Type);
	DDX_Control(pDX, IDC_ARGTYPE1, c_Argument1Type);
	DDX_Control(pDX, IDC_ADDTARGET, c_AddTargetBtn);
	DDX_Control(pDX, IDC_NUMARGSSLIDER, c_NumArgumentsSlider);
	DDX_Control(pDX, IDC_NUMARGSTEXT, c_NumArgumentsText);
	DDX_Control(pDX, IDC_TARGETLIST, c_TargetList);
	DDX_Control(pDX, IDC_TARGETVAL, c_TargetVal);
	DDX_Control(pDX, IDC_ARGUMENT6, c_Argument6);
	DDX_Control(pDX, IDC_ARGUMENT5, c_Argument5);
	DDX_Control(pDX, IDC_ARGUMENT4, c_Argument4);
	DDX_Control(pDX, IDC_ARGUMENT3, c_Argument3);
	DDX_Control(pDX, IDC_ARGUMENT2, c_Argument2);
	DDX_Control(pDX, IDC_ARGUMENT1, c_Argument1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabTargets, CDialog)
	//{{AFX_MSG_MAP(CTabTargets)
	ON_BN_CLICKED(IDC_ADDTARGET, OnAddtarget)
	ON_BN_CLICKED(IDC_REMOVETARGET, OnRemovetarget)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_NUMARGSSLIDER, OnReleasedcaptureNumargsslider)
	ON_NOTIFY(NM_CLICK, IDC_TARGETLIST, OnClickTargetlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabTargets message handlers

void CTabTargets::OnAddtarget() 
{
	int ItemIndex;
	CString GetArgStr;

	if (Updating)
		ItemIndex = c_TargetList.GetSelectionMark();
	else
		ItemIndex = c_TargetList.InsertItem(c_TargetList.GetItemCount(), "");
		
	c_TargetList.SetSelectionMark(-1);

	c_Argument1.GetWindowText(GetArgStr);

	c_TargetList.SetItemText(ItemIndex, 0, GetArgStr);
	if (m_NumArguments > 1)
	{
		c_Argument2.GetWindowText(GetArgStr);
		c_TargetList.SetItemText(ItemIndex, 1, GetArgStr);
	}
	if (m_NumArguments > 2)
	{
		c_Argument3.GetWindowText(GetArgStr);
		c_TargetList.SetItemText(ItemIndex, 2, GetArgStr);
	}
	if (m_NumArguments > 3)
	{
		c_Argument4.GetWindowText(GetArgStr);
		c_TargetList.SetItemText(ItemIndex, 3, GetArgStr);
	}
	if (m_NumArguments > 4)
	{
		c_Argument5.GetWindowText(GetArgStr);
		c_TargetList.SetItemText(ItemIndex, 4, GetArgStr);
	}
	if (m_NumArguments > 5)
	{
		c_Argument6.GetWindowText(GetArgStr);
		c_TargetList.SetItemText(ItemIndex, 5, GetArgStr);
	}

	c_TargetVal.GetWindowText(GetArgStr);
	c_TargetList.SetItemText(ItemIndex, m_NumArguments, GetArgStr);
	c_TargetList.SetScrollPos(SB_VERT, c_TargetList.GetScrollLimit(SB_VERT), TRUE);
	
	c_Argument1.SetWindowText(_T(""));
	c_Argument2.SetWindowText(_T(""));
	c_Argument3.SetWindowText(_T(""));
	c_Argument4.SetWindowText(_T(""));
	c_Argument5.SetWindowText(_T(""));
	c_Argument6.SetWindowText(_T(""));
	c_TargetVal.SetWindowText(_T(""));

	c_AddTargetBtn.SetWindowText("Add");

	Updating = FALSE;

	c_Argument1.SetFocus();
}

void CTabTargets::OnRemovetarget() 
{
	c_TargetList.DeleteItem(c_TargetList.GetSelectionMark());
	c_Argument1.SetWindowText(_T(""));
	c_Argument2.SetWindowText(_T(""));
	c_Argument3.SetWindowText(_T(""));
	c_Argument4.SetWindowText(_T(""));
	c_Argument5.SetWindowText(_T(""));
	c_Argument6.SetWindowText(_T(""));
	c_TargetVal.SetWindowText(_T(""));

	c_AddTargetBtn.SetWindowText("Add");

	Updating = FALSE;

	c_Argument1.SetFocus();
}



void CTabTargets::OnReleasedcaptureNumargsslider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Changes the number of targets *IF* there is no argument list.
	// Can't change on the fly (yet)
	if (c_TargetList.GetItemCount() > 0)
	{
		// Snap back to current
		c_NumArgumentsSlider.SetPos(m_NumArguments);
	}
	else
	{
		// Change columns to number given by new slider position
		int OldNumArgs = m_NumArguments;
		int index;
		CString ColHeader;
		CString FormatIt;

		UpdateData(TRUE);
		m_NumArguments = c_NumArgumentsSlider.GetPos();
		FormatIt.Format("%d", m_NumArguments);
		c_NumArgumentsText.SetWindowText(FormatIt);
		
		// Delete old columns, including "Target Value"
		for (; OldNumArgs >= 0; OldNumArgs--)
			c_TargetList.DeleteColumn(OldNumArgs);
		
		
		for (index = 0; index < m_NumArguments; index++)
		{
			ColHeader.Format("Argument %d", index);
			c_TargetList.InsertColumn(index, ColHeader, LVCFMT_CENTER, 90);
		}

		c_TargetList.InsertColumn(index, "Target Value", LVCFMT_CENTER, 100);

		c_Argument1.EnableWindow(TRUE);
		c_Argument1Type.EnableWindow(TRUE);

		if (m_NumArguments > 1)
		{
			c_Argument2.EnableWindow(TRUE);
			c_Argument2Type.EnableWindow(TRUE);
		}
		else
		{
			c_Argument2.EnableWindow(FALSE);
			c_Argument2Type.EnableWindow(FALSE);
		}

		if (m_NumArguments > 2)
		{
			c_Argument3.EnableWindow(TRUE);
			c_Argument3Type.EnableWindow(TRUE);
		}
		else
		{
			c_Argument3.EnableWindow(FALSE);
			c_Argument3Type.EnableWindow(FALSE);
		}

		if (m_NumArguments > 3)
		{
			c_Argument4.EnableWindow(TRUE);
			c_Argument4Type.EnableWindow(TRUE);
		}
		else
		{
			c_Argument4.EnableWindow(FALSE);
			c_Argument4Type.EnableWindow(FALSE);
		}

		if (m_NumArguments > 4)
		{
			c_Argument5.EnableWindow(TRUE);
			c_Argument5Type.EnableWindow(TRUE);
		}
		else
		{
			c_Argument5.EnableWindow(FALSE);
			c_Argument5Type.EnableWindow(FALSE);
		}

		if (m_NumArguments > 5)
		{
			c_Argument6.EnableWindow(TRUE);
			c_Argument6Type.EnableWindow(TRUE);
		}
		else
		{
			c_Argument6.EnableWindow(FALSE);
			c_Argument6Type.EnableWindow(FALSE);
		}

	}

	*pResult = 0;
}


BOOL CTabTargets::OnInitDialog() 
{

	CDialog::OnInitDialog();
	Updating = FALSE;
	m_NumArguments = 1;

	c_Argument1.EnableWindow(TRUE);
	c_Argument2.EnableWindow(FALSE);
	c_Argument3.EnableWindow(FALSE);
	c_Argument4.EnableWindow(FALSE);
	c_Argument5.EnableWindow(FALSE);
	c_Argument6.EnableWindow(FALSE);
	c_TargetVal.EnableWindow(TRUE);
	c_TargetType.EnableWindow(TRUE);

	c_Argument1Type.EnableWindow(TRUE);
	c_Argument2Type.EnableWindow(FALSE);
	c_Argument3Type.EnableWindow(FALSE);
	c_Argument4Type.EnableWindow(FALSE);
	c_Argument5Type.EnableWindow(FALSE);
	c_Argument6Type.EnableWindow(FALSE);

	c_Argument1Type.SetWindowText("Number");
	c_Argument2Type.SetWindowText("Number");
	c_Argument3Type.SetWindowText("Number");
	c_Argument4Type.SetWindowText("Number");
	c_Argument5Type.SetWindowText("Number");
	c_Argument6Type.SetWindowText("Number");
	c_TargetType.SetWindowText("Number");


	c_TargetList.SetHighlightType(CMyListCtrl::HIGHLIGHT_ALLCOLUMNS);

	c_Argument1.SetFocus();


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTabTargets::OnClickTargetlist(NMHDR* pNMHDR, LRESULT* pResult) 
{

	c_Argument1.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 0));
	if (m_NumArguments > 1)
		c_Argument2.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 1));
	if (m_NumArguments > 2)
		c_Argument3.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 2));
	if (m_NumArguments > 3)
		c_Argument4.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 3));
	if (m_NumArguments > 4)
		c_Argument5.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 4));
	if (m_NumArguments > 5)
		c_Argument6.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), 5));

	c_TargetVal.SetWindowText(c_TargetList.GetItemText(c_TargetList.GetSelectionMark(), m_NumArguments));	
	c_AddTargetBtn.SetWindowText("Store");
	
	Updating = TRUE;
	*pResult = 0;
}
