// TabUserFunctions.cpp : implementation file
//

#include "stdafx.h"
#include "GAPS2.h"
#include "ProgEdit.h"
#include "TabUserFunctions.h"
#include "CGPProgram.h"
#include <afxcmn.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabUserFunctions dialog


CTabUserFunctions::CTabUserFunctions(CWnd* pParent /*=NULL*/)
	: CDialog(CTabUserFunctions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabUserFunctions)
	//}}AFX_DATA_INIT

	m_TotalUserEnteredFunctions = 0;

}


void CTabUserFunctions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabUserFunctions)
	DDX_Control(pDX, IDC_FUNCCOMPILEOUTPUT, c_FunctionCompileOutput);
	DDX_Control(pDX, IDC_FUNCTIONENTRYPNL, c_FunctionText);
	DDX_Control(pDX, IDC_RETURNTYPESELECT, c_ReturnType);
	DDX_Control(pDX, IDC_FUNCTNAME, c_FunctionName);
	DDX_Control(pDX, IDC_FUNCPARAMTEXT, c_FunctWithParamText);
	DDX_Control(pDX, IDC_USERFUNCTSEL, c_UserFunctionSelection);
	DDX_Control(pDX, IDC_FUNCTPARAMLIST, c_FunctParamList);
	DDX_Control(pDX, IDC_PARAMTYPESELECT, c_ParameterType);
	DDX_Control(pDX, IDC_PARAMETERNAME, c_ParameterName);
	DDX_Control(pDX, IDC_RMVFUNCTBTN, m_RemoveFunctionBtn);
	DDX_Control(pDX, IDC_RMVFPARMBTN, m_RemvFunctParamBtn);
	DDX_Control(pDX, IDC_ADDFUNCTBTN, m_AddFunctionBtn);
	DDX_Control(pDX, IDC_ADDFPARMBTN, m_AddFunctParamBtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabUserFunctions, CDialog)
	//{{AFX_MSG_MAP(CTabUserFunctions)
	ON_BN_CLICKED(IDC_ADDFUNCTBTN, OnAddfunctbtn)
	ON_BN_CLICKED(IDC_RMVFUNCTBTN, OnRmvfunctbtn)
	ON_BN_CLICKED(IDC_ADDFPARMBTN, OnAddfparmbtn)
	ON_BN_CLICKED(IDC_RMVFPARMBTN, OnRmvfparmbtn)
	ON_NOTIFY(NM_CLICK, IDC_FUNCTPARAMLIST, OnClickFunctparamlist)
	ON_BN_CLICKED(IDC_COMPILEFUNCBTN, OnCompilefuncbtn)
	ON_EN_CHANGE(IDC_FUNCTNAME, OnChangeFunctname)
	ON_CBN_KILLFOCUS(IDC_RETURNTYPESELECT, OnKillfocusReturntypeselect)
	ON_BN_CLICKED(IDC_CRTNEWFUNCTBTN2, OnCrtnewfunctbtn2)
	ON_NOTIFY(NM_DBLCLK, IDC_USERFUNCTSEL, OnDblclkUserfunctsel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabUserFunctions message handlers

void CTabUserFunctions::OnAddfunctbtn() 
{
	// If already exists, overwrite what's in memory.
	int index;
	int ArgIndex;
	CString PanelFuncName;
	
	c_FunctionName.GetWindowText(PanelFuncName);
	
	for (index = 0; index < m_TotalUserEnteredFunctions; index++)
	{
		if (PanelFuncName == a_UserEnteredFunctions[index].Name)
		{
			c_FunctionText.GetWindowText(a_UserEnteredFunctions[index].Text);
			c_ReturnType.GetWindowText(a_UserEnteredFunctions[index].Type);
			// Store Arguments
			for (ArgIndex = 0; ArgIndex < c_FunctParamList.GetItemCount(); ArgIndex++)
			{
				a_UserEnteredFunctions[index].Arguments[ArgIndex] = c_FunctParamList.GetItemText(ArgIndex, 0);
				a_UserEnteredFunctions[index].ArgumentTypes[ArgIndex] = c_FunctParamList.GetItemText(ArgIndex, 1);
			}
			a_UserEnteredFunctions[index].TotalArguments = c_FunctParamList.GetItemCount();
			return;
		}
	}
	
	// Otherwise, Save it as new

	index = m_TotalUserEnteredFunctions++;
	c_FunctionName.GetWindowText(a_UserEnteredFunctions[index].Name);
	c_FunctionText.GetWindowText(a_UserEnteredFunctions[index].Text);
	c_ReturnType.GetWindowText(a_UserEnteredFunctions[index].Type);
	// Store Arguments
	for (ArgIndex = 0; ArgIndex < c_FunctParamList.GetItemCount(); ArgIndex++)
	{
		a_UserEnteredFunctions[index].Arguments[ArgIndex] = c_FunctParamList.GetItemText(ArgIndex, 0);
		a_UserEnteredFunctions[index].ArgumentTypes[ArgIndex] = c_FunctParamList.GetItemText(ArgIndex, 1);
	}
	a_UserEnteredFunctions[index].TotalArguments = c_FunctParamList.GetItemCount();

	// Add the name into the Function List.
	HTREEITEM NewItem;
	NewItem = c_UserFunctionSelection.InsertItem(a_UserEnteredFunctions[index].Name, UserFnRoot );
	c_UserFunctionSelection.SetCheck(NewItem);
	c_UserFunctionSelection.Expand(UserFnRoot, TVE_EXPAND);
	c_UserFunctionSelection.UpdateWindow();

}

void CTabUserFunctions::OnRmvfunctbtn() 
{
	HTREEITEM Retrieved;
	int index;

	if ((Retrieved = c_UserFunctionSelection.GetSelectedItem()) == NULL ||
		m_TotalUserEnteredFunctions == 0)
		return;

	if (c_UserFunctionSelection.GetParentItem(Retrieved) != UserFnRoot)
		return;

	if (AfxMessageBox(CString("Really remove ") + c_UserFunctionSelection.GetItemText(Retrieved) + CString("?"), MB_YESNO|MB_ICONSTOP) == IDYES)
	{
		bool Deleting = FALSE;
		for (index = 0; index < m_TotalUserEnteredFunctions; index++)
		{
			if (a_UserEnteredFunctions[index].Name == c_UserFunctionSelection.GetItemText(Retrieved))
				Deleting = TRUE;

			if (Deleting && index < m_TotalUserEnteredFunctions - 1)
			{
				a_UserEnteredFunctions[index].Name = a_UserEnteredFunctions[index+1].Name; 
				a_UserEnteredFunctions[index].Text = a_UserEnteredFunctions[index+1].Text; 
				a_UserEnteredFunctions[index].Type = a_UserEnteredFunctions[index+1].Type; 
			}
		}

		m_TotalUserEnteredFunctions--;

		c_UserFunctionSelection.DeleteItem(Retrieved);
		c_FunctionName.SetWindowText("");
		c_FunctionText.SetWindowText("");
		c_ReturnType.SetWindowText("");
		c_FunctParamList.DeleteAllItems();
		c_FunctParamList.UpdateWindow();
	}
}


void CTabUserFunctions::OnCrtnewfunctbtn2() 
{
	c_FunctionName.SetWindowText("");
	c_FunctionText.SetWindowText("");
	c_ReturnType.SetWindowText("");
	c_FunctParamList.DeleteAllItems();
	c_FunctParamList.UpdateWindow();
}

void CTabUserFunctions::OnDblclkUserfunctsel(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	HTREEITEM Retrieved;
	int index;
	int ArgIndex;

	
	if ((Retrieved = c_UserFunctionSelection.GetSelectedItem()) == NULL ||
	 	m_TotalUserEnteredFunctions == 0)
		return;


	c_FunctionName.SetWindowText(c_UserFunctionSelection.GetItemText(Retrieved));

	for (index = 0; index < m_TotalUserEnteredFunctions; index++)
	{
		if (a_UserEnteredFunctions[index].Name == c_UserFunctionSelection.GetItemText(Retrieved))
		{
			c_FunctionText.SetWindowText(a_UserEnteredFunctions[index].Text);
			c_FunctionText.UpdateWindow();
			c_ReturnType.SetWindowText(a_UserEnteredFunctions[index].Type);
			c_ReturnType.UpdateWindow();
			c_FunctParamList.DeleteAllItems();
			for (ArgIndex = 0; ArgIndex < a_UserEnteredFunctions[index].TotalArguments; ArgIndex++)
			{
				c_FunctParamList.InsertItem(ArgIndex, "");
				c_FunctParamList.SetItemText(ArgIndex, 0, a_UserEnteredFunctions[index].Arguments[ArgIndex]);
				c_FunctParamList.SetItemText(ArgIndex, 1, a_UserEnteredFunctions[index].ArgumentTypes[ArgIndex]);
				
			}

			c_ParameterName.UpdateWindow();
			c_ParameterType.UpdateWindow();
			c_FunctParamList.UpdateWindow();
			c_FunctionName.UpdateWindow();
			c_ReturnType.UpdateWindow();
			c_FunctionText.UpdateWindow();
			break;
		}
	}

	UpdateFuncText();
	*pResult = 0;
}


void CTabUserFunctions::UpdateFuncText()
{
	CString FormatIt;
	CString TestStr;

	c_ReturnType.GetWindowText(TestStr);
	if (TestStr.Left(4) == CString("Void"))
		FormatIt = CString("void ");
	if (TestStr.Left(3) == CString("Num"))
		FormatIt = CString("number ");
	if (TestStr.Left(4) == CString("Bool"))
		FormatIt = CString("boolean ");
	if (TestStr.Left(3) == CString("Str"))
		FormatIt = CString("string ");

	c_FunctionName.GetWindowText(TestStr);

	FormatIt += TestStr;

	FormatIt += CString("(");
	
	int index;
	for (index = 0; index < c_FunctParamList.GetItemCount(); index++)
	{
		if (index != 0)
			FormatIt += CString(", ");
		TestStr = c_FunctParamList.GetItemText(index, 1);
		if (TestStr.Left(4) == CString("Void"))
			FormatIt += CString("void ");
		if (TestStr.Left(3) == CString("Num"))
			FormatIt += CString("number ");
		if (TestStr.Left(4) == CString("Bool"))
			FormatIt += CString("boolean ");
		if (TestStr.Left(3) == CString("Str"))
			FormatIt += CString("string ");

		FormatIt += CString("&&") + c_FunctParamList.GetItemText(index, 0);
	}

	FormatIt += CString(")");
	c_FunctWithParamText.SetWindowText(FormatIt);
}

void CTabUserFunctions::OnAddfparmbtn() 
{
	int index;

	CString ParmName;
	CString ParmType;

	c_ParameterName.GetWindowText(ParmName);
	c_ParameterType.GetWindowText(ParmType);

	if (ParmName.GetLength() > 0 &&
		ParmType.GetLength() > 0)
	{
		if (UpdatingParm)
			if (c_FunctParamList.GetSelectedCount() > 0)
				index = c_FunctParamList.GetSelectionMark();
			else
				return;
		else
			index = c_FunctParamList.InsertItem(c_FunctParamList.GetItemCount(), "");
		c_FunctParamList.SetItemText(index, 0, ParmName);
		c_FunctParamList.SetItemText(index, 1, ParmType);
	}
	UpdateFuncText();
}

void CTabUserFunctions::OnRmvfparmbtn() 
{
	if (c_FunctParamList.GetSelectedCount() > 0)
	{
		c_FunctParamList.DeleteItem(c_FunctParamList.GetSelectionMark());
		m_AddFunctParamBtn.SetWindowText(_T("Add"));
		UpdatingParm = FALSE;
	}
	UpdateFuncText();
}


BOOL CTabUserFunctions::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
	// Set up Function List
	UserFnRoot = c_UserFunctionSelection.InsertItem("User Functions");
	BuiltInRoot = c_UserFunctionSelection.InsertItem("Built-In Functions");
	
	c_UserFunctionSelection.Expand(UserFnRoot, TVE_EXPAND);

	// Built-In functions
	c_UserFunctionSelection.InsertItem("Statement If", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement If-Else", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement While", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement DoUntil", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement Push", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement Pop", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement Replace", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Statement :=", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function +", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function -", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function /", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function *", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function %", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function sin", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function cos", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function tan", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function log", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function sqrt", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function round", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function trunc", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("Function abs", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function not", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function &&", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function ||", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function >", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function <", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function >=", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function <=", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function !=", BuiltInRoot);
	c_UserFunctionSelection.InsertItem("B-Function =", BuiltInRoot);

	c_UserFunctionSelection.Expand(BuiltInRoot, TVE_EXPAND);
	c_UserFunctionSelection.ModifyStyle( TVS_CHECKBOXES, 0 );
	c_UserFunctionSelection.ModifyStyle( 0, TVS_CHECKBOXES );

	c_UserFunctionSelection.SetScrollPos(1, 0);


	// Set up Parameter List
	c_FunctParamList.SetHighlightType(CMyListCtrl::HIGHLIGHT_ALLCOLUMNS);
	c_FunctParamList.InsertColumn(0, "Parameter Name", LVCFMT_CENTER, 105);
	c_FunctParamList.InsertColumn(1, "Type", LVCFMT_CENTER, 100);

	c_FunctionName.SetWindowText(_T("Function1"));
	c_ReturnType.SetWindowText(_T("Void"));

	UpdateFuncText();

	UpdatingParm = FALSE;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTabUserFunctions::OnClickFunctparamlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (c_FunctParamList.GetSelectedCount() == 0)
	{
		c_ParameterName.SetWindowText(_T(""));
		c_ParameterType.SetWindowText(_T(""));
		m_AddFunctParamBtn.SetWindowText(_T("Add"));
	}
	else
	{
		c_ParameterName.SetWindowText(c_FunctParamList.GetItemText(c_FunctParamList.GetSelectionMark(), 0));
		c_ParameterType.SetWindowText(c_FunctParamList.GetItemText(c_FunctParamList.GetSelectionMark(), 1));
		m_AddFunctParamBtn.SetWindowText(_T("Update"));
		UpdatingParm = TRUE;
	}

	*pResult = 0;
}

void CTabUserFunctions::OnCompilefuncbtn() 
{
	CGPProgram CompileProg;
	CString FunctionText;

	c_FunctionText.GetWindowText(FunctionText);

	// UPDATE THIS when ready!!
	if (! CompileProg.Compile(FunctionText))
		c_FunctionCompileOutput.SetWindowText("Compile had errors.");
	else
		c_FunctionCompileOutput.SetWindowText("Function compiled with 0 errors.");
	
	int X = 2;
	
}

void CTabUserFunctions::OnChangeFunctname() 
{
	UpdateFuncText();	
}

void CTabUserFunctions::OnKillfocusReturntypeselect() 
{
	UpdateFuncText();	
}


